// CIF wrapper
// $Id: CorbaCif.h,v 1.15 2002/08/17 03:46:15 alexy Exp $

#ifndef _CORBA_CIF_H_
#define _CORBA_CIF_H_

#include <vector>
#include <string>
#include "CifFileObj.h"
#include "util.h"

#include "CorbaCifStruct.h"
#include "CategoryGroup.h"

namespace ccif {

  class CorbaCif
    {
    public:
      CorbaCif::CorbaCif();

      CorbaCif::CorbaCif(const char *cifName, const char *dataBlock);
      virtual ~CorbaCif();
  
      Blocks        blocks(const string category, int& errCode);
      BlockItems    blockItems(const string category, const string block, int& errCode);
      Strings       blockItemNames(const string category, const string block, int& errCode);

      Tensors       tensors(const string category, int& errCode);
      TensorIndexes tensorIndexes(const string category, const string tensor, int& errCode);
      TensorItems   tensorItems(const string category, const string tensor, int& errCode);
      Strings       tensorItemNames(const string category, const string tensor, int& errCode);

      CategorySplits categorySplits();

      Strings       categoryItems(const string, int& errCode);

      bool          categoryStruct(const string);

      IDL::CategoryGroup	    categoryGroup(const string);

    private:
      CifFileObj *cifObj;
      vector <ISTable*> tables;
    };

} // namespace ccif

#endif

