// Corba CIF format body
// $Id$

#include "CorbaCifStruct.h"

namespace ccif {

  const char *tableNames[]
  = { "corba_category_block", "corba_block_items", 
      "corba_tensor", "corba_tensor_index", "corba_tensor_items",
      "category_split", "category_item", "category_struct", "category_class"};

  const char *blockTableColumnNames[] 
    = { "category", "name", "type", NULL };

  const char *blockItemTableColumnNames[]
    = { "category", "block_name", "name", "field", NULL };

  const char *tensorTableColumnNames[] 
    = { "category", "name", "type", "row_order", "kind", NULL };

  const char tensorRowMajor[]       = "row";
  const char tensorKindVector[]     = "vector";
  const char tensorKindSquare[]     = "square";
  const char tensorKindTriangular[] = "triangular";
  const char tensorKindStrange[]    = "STRANGE";

  const char *tensorIndexTableColumnNames[]
    = { "category", "tensor_name", "name", "length", NULL };

  const int  tensorIndexOneBased = 1; // yes; used as offset below

  const char *tensorItemTableColumnNames[]
    = { "category", "tensor_name", "name", "index", "position", NULL };

  // this must be coordinated with CategoryClass.h:
  const char *categoryGroupNames[] = { "", "mms", "xray", "ref", "depo", NULL };
  
  const char **tableColumnNames[] = { blockTableColumnNames,
			        blockItemTableColumnNames,
				tensorTableColumnNames,
				tensorIndexTableColumnNames,
				tensorItemTableColumnNames };

} // namespace ccif
