// Bitarray flags
// $Id: Flags.h,v 1.3 2002/07/26 21:29:49 alexy Exp $

#ifndef _FLAGS_H_
#define _FLAGS_H_

#include <vector>
using namespace std;

namespace flags {
  extern const short MAX_FLAG;
}


class Flags
{
public:
  Flags();
  Flags(const long unsigned bit_size);
  Flags(const unsigned char *buffer, const long unsigned size);
  virtual ~Flags();

  void resize(const long unsigned number);
  void set(const long unsigned number); // will resize the bitarray as neccesary
  bool get(const long unsigned number);

  unsigned char *buffer();
  vector<unsigned char>& vBuffer();

  long unsigned bit_size() const;
  long unsigned byte_size() const;
  long unsigned num_bits() const;
  void num_bits(const long unsigned);

  void load(const unsigned char *buffer, const long unsigned size);
  void show();
private:
  vector<unsigned char> _bytes;
  long unsigned         _bit_size;
  long unsigned         _num_bits;
};

#endif
