// Corba CIF translation
// $Id: Trans.h,v 1.5 2002/07/24 22:56:35 alexy Exp $


#ifndef _TRANS_H_
#define _TRANS_H_ 

#include <vector>
#include <string>
#include <map>

#include "Category.h"
#include "util.h"
#include "Flags.h"

typedef map<string,Category> Categories;

class Trans
{
 public:
  Trans(const char *cifdb, const char *context);

  Strings   categoryNames() const;

  void      setCategory(const string, Category&);
  Category& getCategory(const string);
  bool      hasCategory(const string);
  void      eraseCategory(const string);

  long      numCategories() const;

  void      numberFlags(int& base, const bool split =true); // unused
  void      numberFlags(int& base, const Strings& categories, const bool split =true);
  void      transform();

  string    IDL(const Strings& categories);

  void      setFlags(const Strings& categories, const string& id);
  void      showFlags();
  void      writeFlags();

  void	    clientPrologue(const short tab =0);
  void	    clientEpilogue(const short tab =0);
  
 private:
  Categories _categories;

  bool categoryPresent(const string& name) const;
  
  CifBuilder *_cb;

  void      split();
  string    entryHead(const short t);

  string    _id; // current
  Flags     _flags;
};

#endif
