// CORBA mapping CIF read
// $Id: cifparse.C,v 1.4 2002/06/18 21:54:03 alexy Exp $

#include "CorbaCif.h"
#include <iostream.h>
#include <assert.h>

char cifFile[]   = "/home/alexy/cif/corba.cif";
char dataBlock[] = "cif_corba_mapping";

void main()
{
  ccif::CorbaCif ccif(cifFile, dataBlock);

  ccif::Blocks          blocks;
  ccif::BlockItems      blockItems;

  int errCode;

  string category;

  category = "struct_mon_prot_cis";

  blocks = ccif.blocks(category, errCode);
  if (errCode) { cerr << "ccif.blocks() error" << endl; exit(1); }

  for (int i = 0; i < blocks.size(); ++i) {

    const string& block = blocks[i].name;

    cout << "Category " << category << ", block " << block 
	 << ", items:" << endl;

    blockItems = ccif.blockItems(category, block, errCode);
    if (errCode) { cerr << "ccif.blockItems() error" << endl; exit(1); }

    for (int j = 0; j < blockItems.size(); ++j)
      cout << ' ' << blockItems[j].name;
    cout << endl;

    vector<string> itemNames = ccif.blockItemNames(category, block, errCode);
    if (errCode) { cerr << "ccif.blockItemNames() error" << endl; exit(1); }

    for (int j = 0; j < itemNames.size(); ++j)
      cout << ' ' << itemNames[j];
    cout << endl;
  }

  ccif::Tensors         tensors;
  ccif::TensorItems     tensorItems;

  category = "struct_ncs_oper";

  tensors = ccif.tensors(category, errCode);
  if (errCode) { cerr << "ccif.tensors() error" << endl; exit(1); }

  cout << category << " tensors:" << endl;
  for (int i = 0; i < tensors.size(); ++i) {
    cout << tensors[i].name << endl;

    const string& tensor = tensors[i].name;

    tensorItems = ccif.tensorItems(category, tensor, errCode);
    if (errCode) { cerr << "ccif.tensorItems() error" << endl; exit(1); }

    for (int j = 0; j < tensorItems.size(); ++j) {
      cout << ' ' << tensorItems[j].name;
      for (int k = 0; k < tensorItems[j].pos.size(); ++k)
	cout << '(' << tensorItems[j].pos[k] << ')';
    }
    cout << endl;

    vector<string> tensorItemNames = ccif.tensorItemNames(category, tensor, errCode);
    if (errCode) { cerr << "ccif.tensorItemNames() error" << endl; exit(1); }

    for (int j = 0; j < tensorItemNames.size(); ++j)
      cout << ' ' << tensorItemNames[j];
    cout << endl;
  }
}





