// Single body for global objects
// $Id: global.C,v 1.2 2002/07/24 22:56:35 alexy Exp $

#include "global.h"

#include "options.h"

namespace global {

  CIF               *cif;
 
  ::ccif::CorbaCif  *ccif;

  ::scif::SchemaCif *scif;

  ::db::DB          *db;

  class Cycle
  {
  public:
    Cycle::Cycle();
    virtual Cycle::~Cycle();
  };

  Cycle cycle;
} // namespace global


global::Cycle::Cycle() {}

global::Cycle::~Cycle()
{
  // shutdown(); --  too late, segfaulted
  cerr << "Done." << endl;
}

void global::shutdown()
{
  if (db)   delete db;
  if (cif)  delete cif;
  if (ccif) delete ccif;
  // if (scif) delete scif; -- breaks, why?
}  

void global::create_cif()
{
  global::cif = new CIF();
}


void global::create_ccif()
{
  cerr << "Reading CORBA CIF from " << opt::corbaCifFile << endl;

  global::ccif = new ::ccif::CorbaCif(opt::corbaCifFile, opt::corbaDataBlock);
}


void global::create_scif()
{
  cerr << "Reading Schema CIF from " << opt::schemaCifFile << endl;

  global::scif = new ::scif::SchemaCif(opt::schemaCifFile, opt::schemaDataBlock);
}


void global::db_open()
{
  global::db = new ::db::DB();
}


void global::db_close()
{
  delete global::db;
}
