# Distribution

CIF_DIR = cif
CIF_FILE_NAMES = \
cif_mm.dic.odb		\
cif_mm_V2.0.3.dic	\
corba.cif		\
rcsb_schema.cif		\
#
CIF_FILES = $(CIF_FILE_NAMES:%=$(CIF_DIR)/%)

IDL_DIR = idl
IDL_SOURCE_NAMES = \
C_PropertyService	\
prolog_mms		\
entry_head_mms	\
epilog_mms		\
subentry		\
#
IDL_SOURCES = $(IDL_SOURCE_NAMES:%=$(IDL_DIR)/%.idl)

MISC_SOURCES = \
$(FLAGS_SCRIPT) \
$(FLAGS_BS_C) \
get-cif-gcc_2.95.3.sh \
get-cif-gcc_3.3.sh \
build.sh \
some/Options.patch \
#

MAKEFILE_NAMES = \
Switch \
Layout \
Extern \
Common \
CC.gcc \
CC.gcc.flags \
Objects \
Release \
Deploy \
#
# having MAKEFILES here disrupted the whole freakin' make system w.r.t. subdirs!
THE_MAKEFILES = Makefile $(MAKEFILE_NAMES:%=$(MK)/%.mk)

DOCS = README INSTALL

AUTO_SOURCES = $(AUTO_IDL) $(AUTO_HEADER) $(AUTO_BODY) $(FLAGS_C) $(FLAG_NAMES_C)


SOURCES = \
$(HEADERS) $(BODIES) $(DRIVER_BODIES) \
$(CIF_FILES) $(IDL_SOURCES) \
$(MISC_SOURCES) $(AUTO_SOURCES) \
$(THE_MAKEFILES) $(DOCS) \
#

SUBDIRS = some
LISTFILE = Files
$(LISTFILE): $(SOURCES)
	@$(MakeSubdirs)
	echo $^ > $@
	tr ' ' '\n' < $@ > $@.n
	mv $@.n $@
	for dir in $(SUBDIRS); do sed -e "s|\(.*\)|$$dir/\1|" < $$dir/$@ >> $@; done

RELEASE_NAME = film
RELEASE_DATE = `date +"%Y%m%d"`
TAR = tar zchf
TGZ = tar.gz

BASE=`basename $(PWD)`
export: $(LISTFILE)
	sed -e "s|\(.*\)|$(BASE)/\1|" < $^ >> $^.n
	rm bad.h; ln -s bad.SAMPLE.h bad.h
	(cd some; rm bad.h; ln -s bad.SAMPLE.h bad.h)
	(cd ..; $(TAR) $(BASE)/$(RELEASE_NAME)-$(RELEASE_DATE).$(TGZ) -T $(BASE)/$^.n)
	rm bad.h; ln -s bad.BAD.h bad.h
	(cd some; rm bad.h; ln -s bad.BAD.h bad.h)

filelist: $(LISTFILE)
nofiles:
	rm $(LISTFILE)
	@$(MakeSubdirs)
