#include "Flags.h"
#include "db.h"

int main(int argc, char **argv)
{
  if (argc != 2) {
    cerr << "Usage: " << argv[0] << " <id>" << endl;
    exit(1);
  }

  string id = argv[1];

  Flags flags(::flags::MAX_FLAG);
  cerr << "bit_size = " << flags.bit_size() << ", num_bits = " << flags.num_bits() << endl;

  try {
    db::DB db;
    db.readFlags(flags.vBuffer(), id);
    flags.num_bits(::flags::MAX_FLAG);
  }
  catch (db::DBException &e) {
    cerr << "DBException: " << e.method_name << ", " << e.description << endl;
  }
  catch (...) {
    cerr << "unexpected exception" << endl;
  }

  flags.show();

  return 0;
}

