/*
 *  File:  cell_constants.h
 */

#ifndef __CELL_CONSTANTS_H_
#define __CELL_CONSTANTS_H_

#define NDB_TRANS_FRAC_TO_ORTHO 1
#define NDB_TRANS_ORTHO_TO_FRAC 2

typedef struct _ndb_cell_constant_structure {
  double a,b,c,alpha,beta,gamma;
  int z;
  char space_group[12];
  float o_to_f[3][3];  /* this matrix is used to convert orthos to fracs*/
  float o_to_f_v[3];   /* this vector is an offset applied to fracs */
  float f_to_o[3][3];  /* this  matrix is used to convert fracs to orthos */
  int how_defined;      /* indicates what was defined */
  float o_to_fs[3][3];  /* defined in the PDB SCALE matrix. */
  float f_to_os[3][3];  /* inverse of PDB SCALE matrix */
  float o_to_f_vs[3];    /* this vector is defined in the PDB SCALE matrix*/
  float o_to_fc[3][3];  /* defined from cell constants */
  float f_to_oc[3][3];  /* defined from cell constants */

  float o_to_s[3][3];   /* these are not used */
  float o_to_s_v[3];
} NDBCELLCONST;

#endif





