#ifndef _IO_H_
#define _IO_H_

#include "sym_types.h"
#include "cell_constants.h"
#include "some.h"

namespace mol_symmetry {
int get_spacegroup_info(const char *spgname, SPACE_GROUP *space_group);
NDBSYMMETRY *ndb_get_sym_data(const char *spg_name,char unique_axis, int debug);
void ndb_sym_incr_trans(NDBSYMTRANSDATA* cur_op,int xt, int yt, int zt);

int sym_trans_op1(NDBSYMTRANSDATA* cur_op, MMS::AtomSite &atomCoords,NDBCELLCONST* cell);

void ndb_do_sym_op(MMS::VectorXYZ* tuple, NDBSYMTRANSDATA *op);
void  ndb_trans_coord_3by3(float *x, float *y, float *z,
			   NDBCELLCONST *cell, int iflag);
void ndb_frac_to_ortho_matrix(NDBCELLCONST *cell);
void ndb_ortho_to_frac_matrix(NDBCELLCONST *cell);
void inverse_mat3x3(float a[3][3], float b[3][3]);
void adjoint_mat3x3(float a[3][3], float b[3][3]);
float det3x3(float a[3][3]);
float det2x2(float a, float b, float c, float d);
} // mol_symmetry

#endif
