// Braver Entry Factory
// Factory
// $Id: MMS_EntryFactoryImpl.h,v 1.8 2003/03/11 16:54:24 alexy Exp $

#ifndef MMS_ENTRY_FACTORY_IMPL_H_
#define MMS_ENTRY_FACTORY_IMPL_H_

#include "C_someS.h"

#include "MMS_EntryImpl.h"

class MMS_EntryFactoryImpl :
    public virtual PortableServer::RefCountServantBase,
    public virtual POA_MMS::EntryFactory
{
public:
    MMS_EntryFactoryImpl(PortableServer::POA_ptr) 
      throw (MMS::DataAccessException);

    virtual ~MMS_EntryFactoryImpl();

    // _create() -- create a new servant.
    // Hides the difference between direct inheritance and tie servants.
    static POA_MMS::EntryFactory*
    _create(PortableServer::POA_ptr)
      throw (MMS::DataAccessException);

    virtual PortableServer::POA_ptr
    _default_POA();

    //---------------
    // IDL operations
    //---------------
  
    virtual char* name()
      throw (CORBA::SystemException);
  
    virtual void name(const char* _new_value) 
      throw (CORBA::SystemException);

    virtual MMS::EntryIdList* get_entry_id_list() 
      throw (MMS::DataAccessException);

    virtual CORBA::Long get_entry_id_list_size() 
      throw (MMS::DataAccessException);

    // had to replace MMS::EntryId by const char * below -- why? 
    // `in' parameter-specific? -- see the `in' mapping
    virtual MMS::Entry_ptr get_entry_from_id(const char *) 
      throw (MMS::DataAccessException);

 private:
  // Instance variables for attributes.
  CORBA::String_var               _nameV;
  
  MMS::EntryIdList_var            _entryIdListV;
  
  // POA
  PortableServer::POA_var         _poaV;
  
  void                            load_entry_id_list();
  // do we need to propagate exceptions explicitly declaring them?
  MMS::EntryIdList*		  fetch_entry_id_list()
    throw (CORBA::SystemException, MMS::DataAccessException);

  bool                            _gotEntryIdList;
};

#endif
