// Braver Entry Factory
// Factory body
// $Id: MMS_EntryFactoryList.C,v 1.1 2003/03/11 16:55:41 alexy Exp $

#include "MMS_EntryFactoryImpl.h"

#include "cp.h" // global connection pool connpool::cp

MMS::EntryIdList* MMS_EntryFactoryImpl::fetch_entry_id_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle

    MMS::EntryIdList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        hdbc = connpool::cp.getConnection();
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryFactoryImpl::fetch_entry_id_list()", "no connections!");
    }

    // could do list_size check here, adapt list_size()

    stmt = ( SQLCHAR * )
      "SELECT structure_id FROM DB2INST1.ENTRY";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryFactoryImpl::fetch_entry_id_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryFactoryImpl::fetch_entry_id_list()", "SQLPrepare");

    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryFactoryImpl::fetch_entry_id_list()", "SQLExecute");

     struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } STRUCTURE_ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &STRUCTURE_ID.val, 200, &STRUCTURE_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryFactoryImpl::fetch_entry_id_list()", "SQLBindCol 1");


    listP = new MMS::EntryIdList(0);
    listP->length(0);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryFactoryImpl::fetch_entry_id_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        listP->length(count+1);
        (*listP)[count] = CORBA::string_dup((char*)STRUCTURE_ID.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryFactoryImpl::fetch_entry_id_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryFactoryImpl::fetch_entry_id_list()", "SQLFreeHandle");

finish:
    connpool::cp.returnConnection(hdbc);
    return listP;
}
