// Braver Entry Factory
// Entry
// $Id: MMS_EntryImpl.h,v 1.11 2003/03/09 17:59:28 alexy Exp $

#ifndef MMS_ENTRY_IMPL_H_
#define MMS_ENTRY_IMPL_H_

#include "C_someS.h"
#include "C_PropertyService.h"

#include <string>
using namespace std;

class MMS_EntryImpl :
  public virtual PortableServer::RefCountServantBase,
  public virtual POA_MMS::Entry
{
public:
  MMS_EntryImpl(PortableServer::POA_ptr, const char* id);

  virtual ~MMS_EntryImpl();
  
  // _create() -- create a new servant.
  // Hides the difference between direct inheritance and tie servants.
  static POA_MMS::Entry*
  _create(PortableServer::POA_ptr, const char* id);
  
  virtual PortableServer::POA_ptr
  _default_POA();
  
  //---------------
  // IDL operations
  //---------------
  virtual char* name()
    throw (CORBA::SystemException);
  
  virtual void name(const char* _new_value) 
    throw (CORBA::SystemException);
  
  virtual CORBA::Long value()
    throw (CORBA::SystemException);
  
  virtual void value(const CORBA::Long _new_value) 
    throw (CORBA::SystemException);
  
  virtual CORBA::Long get_value()
    throw (CORBA::SystemException);
  
  virtual char* get_id()
    throw (CORBA::SystemException);

  //---------------
  // MMS Structures
  //---------------

#include "auto/mms.h"
#include "atom.h"
  
MMS::Flags*
MMS_EntryImpl::get_presence_flags()
  throw (CORBA::SystemException, MMS::DataAccessException);


  CORBA::Any * subentry();  

  CosPropertyService::Properties * get_subentry_list();

private:
  // POA
  PortableServer::POA_var         _poaV;
  
  // Entry ID
  CORBA::String_var               _idV;
  string                          _id; // do I need _idV?

  // Instance variables for attributes.
  CORBA::String_var               _nameV;
  CORBA::Long                     _valueV;

#define MAX_FLAGS 100 // better compute from data
  
  unsigned char _optFlags[MAX_FLAGS];

  CORBA::Object_var               _subentryV;

  CosPropertyService::Properties_var _propsV;
};

#endif
