// braver connection pool instance and lifecycle handler
// $Id$

#include "options.h"
#include "cp.h"
#include "dba.h"
#include <iostream> // cerr
#include <cstring>  // strncpy
using namespace std;

namespace connpool {


#define MAX_UID_LENGTH 18
#define MAX_PWD_LENGTH 30
#define MAX_NUM_CONNS  2

  char       dbalias[SQL_MAX_DSN_LENGTH + 1];
  char       user[MAX_UID_LENGTH + 1];
  char       passwd[MAX_PWD_LENGTH + 1];

  // The single conenction pool object is created here!
  ConnectionPool cp;
  // But its activation is deferred into dbcp...
  
  
  dbcp::dbcp()
  {
    cerr << "dba init, dbalias: " << opt::dbalias << "... ";

    strncpy(dbalias, dba::dba->dbalias.c_str(), SQL_MAX_DSN_LENGTH);
    strncpy(user,    dba::dba->user.c_str(),    MAX_UID_LENGTH);
    strncpy(passwd,  dba::dba->passwd.c_str(),  MAX_PWD_LENGTH);

    cp.init(dbalias, user, passwd, MAX_NUM_CONNS);
    cerr << "connection pool manager activated" << endl;
  }

  dbcp::~dbcp()
  {
    cp.disconnectAll();
  }


  Connection::Connection()
  {
    hdbc = cp.getConnection();
  }

  
  Connection::~Connection()
  {
    cp.returnConnection(hdbc);
  }

} // namespace connpool
