SERVER_SPEC_OBJECT_NAMES = \
MMS_EntryImpl \
MMS_EntryFactoryImpl \
Xray_SubentryImpl \
atom \
connpool \
cp \
itoa \
duration \
options \
dba \
#
SERVER_PURE_OBJECT_NAMES = \
MMS_EntryFactoryList \
#
SERVER_OBJECT_NAMES	= $(SERVER_SPEC_OBJECT_NAMES) $(SERVER_PURE_OBJECT_NAMES)
SERVER_OBJECTS		= $(SERVER_OBJECT_NAMES:%=$(OBJ_DIR)/%.o)

CLIENT_PURE_OBJECT_NAMES =
CLIENT_SPEC_OBJECT_NAMES = optionc show
CLIENT_OBJECT_NAMES 	= $(CLIENT_SPEC_OBJECT_NAMES) $(CLIENT_PURE_OBJECT_NAMES)
CLIENT_OBJECTS		= $(CLIENT_OBJECT_NAMES:%=$(OBJ_DIR)/%.o)

MAIN_PURE_OBJECT_NAMES  =
MAIN_SPEC_OBJECT_NAMES  = optionc
MAIN_OBJECT_NAMES 	= $(MAIN_SPEC_OBJECT_NAMES) $(MAIN_PURE_OBJECT_NAMES)
MAIN_OBJECTS		= $(MAIN_OBJECT_NAMES:%=$(OBJ_DIR)/%.o)

# common for client and server:
CS_NONIDL_PURE_OBJECT_NAMES =
CS_NONIDL_SPEC_OBJECT_NAMES = C_ExceptionStream
CS_NONIDL_OBJECT_NAMES	= $(CS_NONIDL_SPEC_OBJECT_NAMES) $(CS_NONIDL_PURE_OBJECT_NAMES)
CS_NONIDL_OBJECTS	= $(CS_NONIDL_OBJECT_NAMES:%=$(OBJ_DIR)/%.o)

# biol.o is both part of the server and wrapper's libwrap,
# what's a good way to factor it out?
BIOL 			= biol
WRAP_PURE_OBJECT_NAMES	=
WRAP_SPEC_OBJECT_NAMES	= wrapper mms_biol $(BIOL)
WRAP_OBJECT_NAMES	= $(WRAP_SPEC_OBJECT_NAMES) $(WRAP_PURE_OBJECT_NAMES)
WRAP_OBJECTS		= $(WRAP_OBJECT_NAMES:%=$(OBJ_DIR)/%.o)

BIOL_O			= $(OBJ_DIR)/$(BIOL).o

WRAP_ROOT		= wraporb
LIBWRAP			= $(LIB_DIR)/lib$(WRAP_ROOT).a

# Basically same as client, just more of them
# client.annotated 
CLIENT_PROGRAM_NAMES	= client main
SERVER_PROGRAM_NAMES	= server
PROGRAM_NAMES		= $(CLIENT_PROGRAM_NAMES) $(SERVER_PROGRAM_NAMES)
PROGRAMS		= $(PROGRAM_NAMES:%=$(BIN_DIR)/%)
DRIVER_OBJECTS		= $(PROGRAM_NAMES:%=$(OBJ_DIR)/%.o)

SERVER = $(BIN_DIR)/server
CLIENT = $(BIN_DIR)/client
MAIN   = $(BIN_DIR)/main

# The partition of BIOLGEN_OBJECTS into _HERE and _THERE is dictated
# by the suffix rules below...  A better way?

OBJECTS			= $(SERVER_OBJECTS) $(CLIENT_OBJECTS) $(CS_NONIDL_OBJECTS) \
			  $(DRIVER_OBJECTS) \
			  $(WRAP_OBJECTS)

# for server and client targets:
CS_OBJECTS		= $(IDLOBJ) $(CS_NONIDL_OBJECTS)


# prefix with OBJ_DIR?  Set vpath/VPATH?
$(DRIVER_OBJECTS): $(IDLCXX)

# $(PROGRAMS): $(PROGRAM_NAMES)
$(PROGRAMS): $(BIN_DIR)/%: $(OBJ_DIR)/%.o

$(LIBWRAP): $(WRAP_OBJECTS)
	ar cr $@ $^

$(OBJECTS): $(OBJ_DIR)/%.o: %.C
	$(CXX) $(CXXFLAGS) -c $< -o $@

