CLIENT_PURE_HEADER_NAMES = \
C_NamingService		\
C_PropertyService	\
C_someC			\
C_subentryC		\
io			\
#

SERVER_PURE_HEADER_NAMES = \
C_someS			\
list_size		\
bad			\
#
PURE_HEADER_NAMES	= $(CLIENT_PURE_HEADER_NAMES) $(SERVER_PURE_HEADER_NAMES)
PURE_HEADERS		= $(PURE_HEADER_NAMES:%=%.$h)
CLIENT_PURE_HEADERS	= $(CLIENT_PURE_HEADER_NAMES:%=%.$h) 

CLIENT_SPEC_HEADER_NAMES = \
$(CLIENT_SPEC_OBJECT_NAMES) \
$(WRAP_SPEC_OBJECT_NAMES) \
$(CS_NONIDL_SPEC_OBJECT_NAMES) \
#
SERVER_SPEC_HEADER_NAMES = \
$(SERVER_SPEC_OBJECT_NAMES) \
#
SPEC_HEADER_NAMES	= $(CLIENT_SPEC_HEADER_NAMES) $(SERVER_SPEC_HEADER_NAMES)
SPEC_HEADERS		= $(SPEC_HEADER_NAMES:%=%.$h)
CLIENT_SPEC_HEADERS	= $(CLIENT_SPEC_HEADER_NAMES:%=%.$h)

HEADERS = $(PURE_HEADERS) $(SPEC_HEADERS)
CLIENT_HEADERS 		= $(CLIENT_PURE_HEADERS) $(CLIENT_SPEC_HEADERS) \
			  $(CS_NONIDL_SPEC_HEADERS)


SPEC_BODIES		= $(SPEC_HEADERS:%.$h=%.$C)
CLIENT_SPEC_BODIES	= $(CLIENT_SPEC_HEADERS:%.$h=%.$C)

CLIENT_PURE_BODY_NAMES = \
$(CLIENT_PROGRAM_NAMES) \
#
SERVER_PURE_BODY_NAMES = \
$(SERVER_PURE_OBJECT_NAMES) \
$(SERVER_PROGRAM_NAMES) \
#
PURE_BODY_NAMES		= $(CLIENT_PURE_BODY_NAMES) $(SERVER_PURE_BODY_NAMES)
PURE_BODIES		= $(PURE_BODY_NAMES:%=%.$C)
CLIENT_PURE_BODIES	= $(CLIENT_PURE_BODY_NAMES:%=%.$C)

BODIES			= $(PURE_BODIES) $(SPEC_BODIES)
CLIENT_BODIES		= $(CLIENT_SPEC_BODIES) $(CLIENT_PURE_BODIES)


ORB_MAKEFILE_NAMES = $(ORB_TYPES:%=Orb.%) $(ORB_TYPES:%=Idl.%)
MAKEFILE_NAMES = \
Switch \
$(ORB_MAKEFILE_NAMES) \
Orb \
Prepare \
Layout \
Extern \
CC.gcc \
CC.gcc.flags \
Objects \
Release \
Common \
Deploy \
Clean \
#
# having MAKEFILES here disrupted the whole freakin' make system w.r.t. subdirs!
THE_MAKEFILES = Makefile $(MAKEFILE_NAMES:%=$(MK)/%.mk)

OPTIONS_PATCH = Options.patch
README_CLIENT_CXX = README.client.C++
CLIENT_NOMAKE =   $(CLIENT_HEADERS) $(CLIENT_BODIES) \
		  $(IDLIDL) $(IDLCXX) \
		  $(OPTIONS_PATCH) $(README_CLIENT_CXX)
CLIENT = $(CLIENT_NOMAKE) $(THE_MAKEFILES)

README_CLIENT_PYTHON = README.client.python
# duplicate some.idl?
CLIENT_PYTHON = some.idl \
client.py \
python.setup.sh \
$(README_CLIENT_PYTHON)
#

DOCS = \
$(README_CLIENT_CXX) \
# $(README_CLIENT_PYTHON) \ -- included with CLIENT_PYTHON
#

MISC_SOURCES = \
client.pdb.py \
$(OPTIONS_PATCH)

# where's $(IDLIDL)?
SOURCES = $(HEADERS) $(BODIES) $(THE_MAKEFILES) $(MISC_SOURCES) $(DOCS) $(IDLCXX)


LISTFILE = Files
$(LISTFILE): $(SOURCES)
	@$(MakeSubdirs)
	echo $^ > $@
# 	perl -pi perline.pl $@
	tr ' ' '\n' < $@ > $@.n
	mv $@.n $@
	for dir in $(SUBDIRS); do sed -e "s|\(.*\)|$$dir/\1|" < $$dir/$@ >> $@; done

RELEASE_NAME = film.cs
CLIENT_CXX_RELEASE_NAME = film.client.C++
CLIENT_CXX_NOMAKE_RELEASE_NAME = film.client.C++.nomake
CLIENT_PYTHON_RELEASE_NAME = film.client.python

RELEASE_DATE = `date +"%Y%m%d"`
TAR = tar zchf
TGZ = tar.gz


filelist: $(LISTFILE)
nofiles:
	rm $(LISTFILE)
	@$(MakeSubdirs)


export: $(LISTFILE)
	$(TAR) $(RELEASE_NAME)-$(RELEASE_DATE).$(TGZ) -T $^

client_export: $(CLIENT)
	$(TAR) $(CLIENT_CXX_RELEASE_NAME)-$(RELEASE_DATE).$(TGZ) $^

client_nomake: $(CLIENT_NOMAKE)
	$(TAR) $(CLIENT_CXX_NOMAKE_RELEASE_NAME)-$(RELEASE_DATE).$(TGZ) $^

python: $(CLIENT_PYTHON)
	$(TAR) $(CLIENT_PYTHON_RELEASE_NAME)-$(RELEASE_DATE).$(TGZ) $^
