// Relevance Feedback
// Options

const char *vc_rf_options =
"$Name:  $ $RCSfile: options.C,v $ $Revision: 1.13 $";

#include "optionc.h"

#include <Options.h> // Brad Appleton's
#include <iostream>
#include <cstdlib> // -- needed for exit(1)?!
#include <cstring> // atoi
using namespace std;

namespace opt {

static const char * optv[] = {
  "?|help",
  "d:database",
  "i:id",
  NULL
} ;
  
  char *xdb = 0;
  const char xdb_default[] = "NDB";
  
  char *sid = 0;
  const char sid_default_pdb[] = "1J59";
  const char sid_default_ndb[] = "PD0299";
  
void parse(int argc, char **argv, const bool need_files)
{
  int  optchar;
  const char * optarg;

  int  errors = 0;

  Options  opts(*argv, optv);
  OptArgvIter  iter(--argc, ++argv);

  opts.ctrls(Options::PARSE_POS);
  while( (optchar = opts(iter, optarg)) ) {
    switch (optchar) {
    case '?' :
      opts.usage(cout, (const char*)"files ...");
      exit(0);
      break;
    case 'd':
      xdb = (char*) optarg;
      break;
    case 'i':
      sid = (char*) optarg;
      break;
    default :  ++errors; break;
    } //switch
  }

  if (errors || need_files && (iter.index() == argc)) {
    if (! errors) 
      cerr << opts.name() << ": no filenames given." << endl ;
    opts.usage(cerr, (const char*)"files ...");
    exit(1);
  }

  if (! xdb) xdb = (char*) xdb_default;
  if (! sid) sid = (char*) (strcmp(xdb, xdb_default) ? sid_default_pdb : sid_default_ndb);
} // parse

} // namespace opt
