// Relevance Feedback
// Options

const char *vc_rf_options =
"$Name:  $ $RCSfile: options.C,v $ $Revision: 1.13 $";

#include "options.h"
#include "dba.h" // dbalias sets dba::dba
#include <Options.h> // Brad Appleton's
#include <iostream>
#include <cstdlib> // -- needed for exit(1)?!
#include <cstring> // atoi
using namespace std;

namespace opt {

static const char * optv[] = {
  "?|help",
  "d:database",
  NULL
} ;
  
  string dbalias = "";
  const string dbalias_default = "ndb4";
  
void parse(int argc, char **argv, const bool need_files)
{
  int  optchar;
  const char * optarg;

  int  errors = 0;

  Options  opts(*argv, optv);
  OptArgvIter  iter(--argc, ++argv);

  opts.ctrls(Options::PARSE_POS);
  while( (optchar = opts(iter, optarg)) ) {
    switch (optchar) {
    case '?' :
      opts.usage(cout, (const char*)"files ...");
      exit(0);
      break;
    case 'd':
      dbalias = string(optarg);
      break;
    default :  ++errors; break;
    } //switch
  }

  if (errors || need_files && (iter.index() == argc)) {
    if (! errors) 
      cerr << opts.name() << ": no filenames given." << endl ;
    opts.usage(cerr, (const char*)"files ...");
    exit(1);
  }

  if (! dbalias.size()) {
    dbalias = (string) dbalias_default;
    cerr << "using default database " << dbalias << endl;
  }
  // create a database access structure based on the alias
  dba::dba = new dba::DBAccess(opt::dbalias);

} // parse

} // namespace opt
