// wrap CORBA client for external use
// $Rev$ $Id: wrapper.h,v 1.7 2003/06/05 21:14:58 alexy Exp $

#ifndef _WRAPPER_H_
#define _WRAPPER_H_

#include <string>
#include <vector>
using namespace std;

#include "biol.h"

namespace orb {

  struct DataAccessException {
    DataAccessException(char *method_name, char *description);
    string method_name;
    string description;
  };
  
  class Factory;
  
  class FactoryBody;
  class EntryBody;
  
  class Entry
  {
    friend class Factory;
  public:
    Entry(const char *const entry_id) throw (DataAccessException);
    virtual ~Entry();

    long atom_list_size();
    biol::AtomSiteList	get_atom_site_list();

    biol::SymInfo	get_sym_info();
    biol::AsymUnit	get_asym_unit();
    biol::BiolGenList	get_biol_gen(int);
    biol::BiolUnit	get_biol_unit(int);
    // as opposed to using a client-side biol_gen:
    // biol::BiolUnit	get_biol_unit_directly(int);
    long 		biol_unit_list_size();
    // biol::BiolUnitList	get_biol_unit_list();
    
  private:
    static Factory *factory;
    EntryBody      *ptr;
  }; // Entry

  
  // Wrap ORB
  class Factory
  {
  public:
    // ORB init., prefercthes ORB-specific arguments
    Factory(int &argc, char ** &argv);
    virtual ~Factory();
      
    FactoryBody *ptr;
  };

} // namespace orb
#endif
