#include <iostream.h>
#include "CifBuilder.h"

#include "options.h"
#include "SchemaCif.h"

int main(int argc, char ** argv) {
  
  opt::parse(argc, argv);

  assert(opt::schemaCifFile);
  assert(opt::schemaDataBlock);

  cerr << "Reading RCSB schema CIF from " 
       << opt::schemaCifFile << endl;

  global::scif = new scif::SchemaCif(opt::schemaCifFile, opt::schemaDataBlock);

  string category = "atom_site";
  string item = "aniso_B[1][1]";

  string s = global::scif->abbrev(category, item);

  cout << category << '.' << item << ": " << (s != "" ? s : "has no abbrev") << endl;

  category = "atom_site";
  item = "id";

  s = global::scif->abbrev(category, item);

  cout << category << '.' << item << ": " << (s != "" ? s : "has no abbrev") << endl;

  exit(0);
}



