// braver utilities body
// $Id: util.C,v 1.6 2002/07/15 23:44:12 alexy Exp $

#include "util.h"
#include <algorithm>
#include <assert.h>
// all of these:?
#include <sstream>
#include <fstream>
#include <iostream>
using namespace std;

bool util::hasSuffix(const string s, const string suffix)
{
  int pos = s.size() - suffix.size();

  if (pos < 0) return false;

  return s.substr(pos) == suffix;
}


string util::cutSuffix(const string s, const string suffix)
{
  int pos = s.size() - suffix.size();

  if (pos < 0) return s;

  string r = s;

  if (r.substr(pos) == suffix) return r.erase(pos);
  else return r;
}


bool util::hasSubstr(const string s, const string sub)
{
  return s.find(sub) != string::npos;
}


string util::cutSubstr(const string s, const string sub)
{
  size_t i = s.find(sub);

  if (i == string::npos) return s;
  else { string r = s; return r.erase(i, sub.length()); }
}


bool util::present(const vector<string>& v, const string s)
{
  return find(v.begin(), v.end(), s) != v.end();
}


bool util::erase(vector<string>& v, const string s)
{
  vector<string>::iterator it = find(v.begin(), v.end(), s);
  if (it == v.end()) return false;
  v.erase(it);
  return true;
}


void util::print_cout(const vector<string>& v)
{
  for (int i = 0; i < v.size(); ++i) cout << ' ' << v[i]; 
  cout << endl;
}


void util::print_cerr(const vector<string>& v)
{
  for (int i = 0; i < v.size(); ++i) cerr << ' ' << v[i]; 
  cerr << endl;
}


string util::upper(const string s)
{
  string r;

  for (int i = 0; i < s.length(); ++i)
    if (islower(s[i])) r += toupper(s[i]);
    else r += s[i];

  return r;
}
	

string util::lower(const string s)
{
  string r;

  for (int i = 0; i < s.length(); ++i)
    if (isupper(s[i])) r += tolower(s[i]);
    else r += s[i];

  return r;
}


string util::uncap(const string s)
{
  if (!s.length()) return "";

  string r = s;
  r[0] = tolower(r[0]);
  return r;
}


string util::str(const int n)
{
  stringstream sn;
  sn << n;
  return sn.str();
}


void util::replace(string &s, const string from, const string to)
{
  size_t i = s.find(from);
  if (i == string::npos) return;

  s.replace(i, from.length(), to);
}


string util::_2Title(const string s)
{
  string r = s;

  if (r.length()) r[0] = toupper(r[0]);

  for (int i = 0; i < r.length(); ++i)
    if (r[i] == '_') {
      if (i == r.length() - 1) break;
      ++i;
      r[i] = toupper(r[i]);
      // cerr << '[' << r[i] << ']';
      for (++i; i < r.length() && r[i] != '_'; ++i)
	r[i] = tolower(r[i]);
      --i;
    }

  for (int i = r.length() - 1; i >= 0; --i)
    if (r[i] == '_') r.erase(i, 1);

  return r;
}


string util::readFile(const char *const filename)
{
    string r;

    ifstream in(filename);
    assert(in);
    
    char c;
    while((c = in.get()) != EOF) r += c;
    in.close();
    
    return r;
}
