CORBA::Long
MMS_EntryImpl::atom_site_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.ATOM_SITE WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_list_size() SQLFetch", itoa(sqlrc));

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::AtomSiteList*
MMS_EntryImpl::get_atom_site_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::AtomSiteList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "ATOM_SITE", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT B_ISO_OR_EQUIV,GROUP_PDB,ID,OCCUPANCY,LABEL_ENTITY_ID,TYPE_SYMBOL,CARTN_X,CARTN_Y,CARTN_Z,LABEL_ALT_ID,LABEL_ASYM_ID,LABEL_ATOM_ID,LABEL_COMP_ID,LABEL_SEQ_ID FROM DB2INST1.ATOM_SITE WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } B_ISO_OR_EQUIV;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } GROUP_PDB;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ID;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } OCCUPANCY;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } LABEL_ENTITY_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } TYPE_SYMBOL;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } CARTN_X;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } CARTN_Y;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } CARTN_Z;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } LABEL_ALT_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } LABEL_ASYM_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } LABEL_ATOM_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } LABEL_COMP_ID;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } LABEL_SEQ_ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_DOUBLE, &B_ISO_OR_EQUIV.val, 0, &B_ISO_OR_EQUIV.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &GROUP_PDB.val, 10, &GROUP_PDB.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &ID.val, 10, &ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_DOUBLE, &OCCUPANCY.val, 0, &OCCUPANCY.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_list()", "SQLBindCol 4");

    sqlrc = SQLBindCol( hstmt, 5, SQL_C_CHAR, &LABEL_ENTITY_ID.val, 10, &LABEL_ENTITY_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_list()", "SQLBindCol 5");

    sqlrc = SQLBindCol( hstmt, 6, SQL_C_CHAR, &TYPE_SYMBOL.val, 10, &TYPE_SYMBOL.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_list()", "SQLBindCol 6");

    sqlrc = SQLBindCol( hstmt, 7, SQL_C_DOUBLE, &CARTN_X.val, 0, &CARTN_X.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_list()", "SQLBindCol 7");

    sqlrc = SQLBindCol( hstmt, 8, SQL_C_DOUBLE, &CARTN_Y.val, 0, &CARTN_Y.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_list()", "SQLBindCol 8");

    sqlrc = SQLBindCol( hstmt, 9, SQL_C_DOUBLE, &CARTN_Z.val, 0, &CARTN_Z.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_list()", "SQLBindCol 9");

    sqlrc = SQLBindCol( hstmt, 10, SQL_C_CHAR, &LABEL_ALT_ID.val, 10, &LABEL_ALT_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_list()", "SQLBindCol 10");

    sqlrc = SQLBindCol( hstmt, 11, SQL_C_CHAR, &LABEL_ASYM_ID.val, 10, &LABEL_ASYM_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_list()", "SQLBindCol 11");

    sqlrc = SQLBindCol( hstmt, 12, SQL_C_CHAR, &LABEL_ATOM_ID.val, 6, &LABEL_ATOM_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_list()", "SQLBindCol 12");

    sqlrc = SQLBindCol( hstmt, 13, SQL_C_CHAR, &LABEL_COMP_ID.val, 10, &LABEL_COMP_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_list()", "SQLBindCol 13");

    sqlrc = SQLBindCol( hstmt, 14, SQL_C_LONG, &LABEL_SEQ_ID.val, 0, &LABEL_SEQ_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_list()", "SQLBindCol 14");

    listP = new MMS::AtomSiteList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].b_iso_or_equiv = B_ISO_OR_EQUIV.val;
        (*listP)[count].group_pdb = CORBA::string_dup((char*)GROUP_PDB.val);
        (*listP)[count].id = CORBA::string_dup((char*)ID.val);
        (*listP)[count].occupancy = OCCUPANCY.val;
        (*listP)[count].label_entity.id = CORBA::string_dup((char*)LABEL_ENTITY_ID.val);
        (*listP)[count].label_entity.index = atoi((char*)LABEL_ENTITY_ID.val);
        (*listP)[count].type_symbol.id = CORBA::string_dup((char*)TYPE_SYMBOL.val);
        (*listP)[count].type_symbol.index = atoi((char*)TYPE_SYMBOL.val);
        (*listP)[count].cartn.x = CARTN_X.val;
        (*listP)[count].cartn.y = CARTN_Y.val;
        (*listP)[count].cartn.z = CARTN_Z.val;
        (*listP)[count].label.atom.id = CORBA::string_dup((char*)LABEL_ATOM_ID.val);
        (*listP)[count].label.atom.index = atoi((char*)LABEL_ATOM_ID.val);
        (*listP)[count].label.alt.id = CORBA::string_dup((char*)LABEL_ALT_ID.val);
        (*listP)[count].label.alt.index = atoi((char*)LABEL_ALT_ID.val);
        (*listP)[count].label.asym.id = CORBA::string_dup((char*)LABEL_ASYM_ID.val);
        (*listP)[count].label.asym.index = atoi((char*)LABEL_ASYM_ID.val);
        (*listP)[count].label.comp.id = CORBA::string_dup((char*)LABEL_COMP_ID.val);
        (*listP)[count].label.comp.index = atoi((char*)LABEL_COMP_ID.val);
        (*listP)[count].label.seq.id = itoa(LABEL_SEQ_ID.val);
        (*listP)[count].label.seq.index = LABEL_SEQ_ID.val;

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::atom_site_anisotrop_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.ATOM_SITE_ANISOTROP WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_anisotrop_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_anisotrop_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_anisotrop_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_anisotrop_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_anisotrop_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_anisotrop_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_anisotrop_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_anisotrop_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_anisotrop_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::AtomSiteAnisotropList*
MMS_EntryImpl::get_atom_site_anisotrop_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::AtomSiteAnisotropList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_anisotrop_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "ATOM_SITE_ANISOTROP", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT ID,TYPE_SYMBOL,U11,U12,U13,U22,U23,U33,U11_ESD,U12_ESD,U13_ESD,U22_ESD,U23_ESD,U33_ESD FROM DB2INST1.ATOM_SITE_ANISOTROP WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_anisotrop_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_anisotrop_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_anisotrop_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_anisotrop_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } TYPE_SYMBOL;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } U11;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } U12;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } U13;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } U22;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } U23;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } U33;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } U11_ESD;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } U12_ESD;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } U13_ESD;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } U22_ESD;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } U23_ESD;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } U33_ESD;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &ID.val, 10, &ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_anisotrop_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &TYPE_SYMBOL.val, 10, &TYPE_SYMBOL.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_anisotrop_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_DOUBLE, &U11.val, 0, &U11.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_anisotrop_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_DOUBLE, &U12.val, 0, &U12.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_anisotrop_list()", "SQLBindCol 4");

    sqlrc = SQLBindCol( hstmt, 5, SQL_C_DOUBLE, &U13.val, 0, &U13.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_anisotrop_list()", "SQLBindCol 5");

    sqlrc = SQLBindCol( hstmt, 6, SQL_C_DOUBLE, &U22.val, 0, &U22.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_anisotrop_list()", "SQLBindCol 6");

    sqlrc = SQLBindCol( hstmt, 7, SQL_C_DOUBLE, &U23.val, 0, &U23.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_anisotrop_list()", "SQLBindCol 7");

    sqlrc = SQLBindCol( hstmt, 8, SQL_C_DOUBLE, &U33.val, 0, &U33.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_anisotrop_list()", "SQLBindCol 8");

    sqlrc = SQLBindCol( hstmt, 9, SQL_C_DOUBLE, &U11_ESD.val, 0, &U11_ESD.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_anisotrop_list()", "SQLBindCol 9");

    sqlrc = SQLBindCol( hstmt, 10, SQL_C_DOUBLE, &U12_ESD.val, 0, &U12_ESD.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_anisotrop_list()", "SQLBindCol 10");

    sqlrc = SQLBindCol( hstmt, 11, SQL_C_DOUBLE, &U13_ESD.val, 0, &U13_ESD.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_anisotrop_list()", "SQLBindCol 11");

    sqlrc = SQLBindCol( hstmt, 12, SQL_C_DOUBLE, &U22_ESD.val, 0, &U22_ESD.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_anisotrop_list()", "SQLBindCol 12");

    sqlrc = SQLBindCol( hstmt, 13, SQL_C_DOUBLE, &U23_ESD.val, 0, &U23_ESD.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_anisotrop_list()", "SQLBindCol 13");

    sqlrc = SQLBindCol( hstmt, 14, SQL_C_DOUBLE, &U33_ESD.val, 0, &U33_ESD.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_anisotrop_list()", "SQLBindCol 14");

    listP = new MMS::AtomSiteAnisotropList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_anisotrop_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].id.id = CORBA::string_dup((char*)ID.val);
        (*listP)[count].id.index = atoi((char*)ID.val);
        (*listP)[count].type_symbol.id = CORBA::string_dup((char*)TYPE_SYMBOL.val);
        (*listP)[count].type_symbol.index = atoi((char*)TYPE_SYMBOL.val);
        (*listP)[count].u[0][0] = U11.val;
        (*listP)[count].u[0][1] = U12.val;
        (*listP)[count].u[0][2] = U13.val;
        (*listP)[count].u[1][1] = U22.val;
        (*listP)[count].u[1][2] = U23.val;
        (*listP)[count].u[2][2] = U33.val;
        (*listP)[count].u_esd[0][0] = U11_ESD.val;
        (*listP)[count].u_esd[0][1] = U12_ESD.val;
        (*listP)[count].u_esd[0][2] = U13_ESD.val;
        (*listP)[count].u_esd[1][1] = U22_ESD.val;
        (*listP)[count].u_esd[1][2] = U23_ESD.val;
        (*listP)[count].u_esd[2][2] = U33_ESD.val;

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_anisotrop_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_anisotrop_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::atom_site_ext_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.ATOM_SITE WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_ext_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_ext_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_ext_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_ext_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_ext_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_ext_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_ext_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_ext_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_site_ext_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::AtomSiteExtList*
MMS_EntryImpl::get_atom_site_ext_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::AtomSiteExtList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_ext_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "ATOM_SITE", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT B_ISO_OR_EQUIV_ESD,AUTH_ASYM_ID,AUTH_ATOM_ID,AUTH_COMP_ID,AUTH_SEQ_ID,OCCUPANCY_ESD,CARTN_X_ESD,CARTN_Y_ESD,CARTN_Z_ESD FROM DB2INST1.ATOM_SITE WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_ext_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_ext_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_ext_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_ext_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } B_ISO_OR_EQUIV_ESD;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } AUTH_ASYM_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } AUTH_ATOM_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } AUTH_COMP_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } AUTH_SEQ_ID;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } OCCUPANCY_ESD;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } CARTN_X_ESD;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } CARTN_Y_ESD;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } CARTN_Z_ESD;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_DOUBLE, &B_ISO_OR_EQUIV_ESD.val, 0, &B_ISO_OR_EQUIV_ESD.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_ext_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &AUTH_ASYM_ID.val, 10, &AUTH_ASYM_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_ext_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &AUTH_ATOM_ID.val, 6, &AUTH_ATOM_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_ext_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_CHAR, &AUTH_COMP_ID.val, 10, &AUTH_COMP_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_ext_list()", "SQLBindCol 4");

    sqlrc = SQLBindCol( hstmt, 5, SQL_C_CHAR, &AUTH_SEQ_ID.val, 10, &AUTH_SEQ_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_ext_list()", "SQLBindCol 5");

    sqlrc = SQLBindCol( hstmt, 6, SQL_C_DOUBLE, &OCCUPANCY_ESD.val, 0, &OCCUPANCY_ESD.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_ext_list()", "SQLBindCol 6");

    sqlrc = SQLBindCol( hstmt, 7, SQL_C_DOUBLE, &CARTN_X_ESD.val, 0, &CARTN_X_ESD.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_ext_list()", "SQLBindCol 7");

    sqlrc = SQLBindCol( hstmt, 8, SQL_C_DOUBLE, &CARTN_Y_ESD.val, 0, &CARTN_Y_ESD.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_ext_list()", "SQLBindCol 8");

    sqlrc = SQLBindCol( hstmt, 9, SQL_C_DOUBLE, &CARTN_Z_ESD.val, 0, &CARTN_Z_ESD.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_ext_list()", "SQLBindCol 9");

    listP = new MMS::AtomSiteExtList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_ext_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].b_iso_or_equiv_esd = B_ISO_OR_EQUIV_ESD.val;
        (*listP)[count].auth_asym_id = CORBA::string_dup((char*)AUTH_ASYM_ID.val);
        (*listP)[count].auth_atom_id = CORBA::string_dup((char*)AUTH_ATOM_ID.val);
        (*listP)[count].auth_comp_id = CORBA::string_dup((char*)AUTH_COMP_ID.val);
        (*listP)[count].auth_seq_id = CORBA::string_dup((char*)AUTH_SEQ_ID.val);
        (*listP)[count].occupancy_esd = OCCUPANCY_ESD.val;
        (*listP)[count].cartn_esd.x = CARTN_X_ESD.val;
        (*listP)[count].cartn_esd.y = CARTN_Y_ESD.val;
        (*listP)[count].cartn_esd.z = CARTN_Z_ESD.val;

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_ext_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_site_ext_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::atom_type_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.ATOM_TYPE WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::atom_type_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_type_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_type_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_type_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_type_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_type_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_type_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_type_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::atom_type_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::AtomTypeList*
MMS_EntryImpl::get_atom_type_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::AtomTypeList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_type_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "ATOM_TYPE", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT SYMBOL FROM DB2INST1.ATOM_TYPE WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_type_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_type_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_type_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_type_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } SYMBOL;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &SYMBOL.val, 10, &SYMBOL.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_type_list()", "SQLBindCol 1");

    listP = new MMS::AtomTypeList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_type_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].symbol = CORBA::string_dup((char*)SYMBOL.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_atom_type_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_atom_type_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::chem_comp_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.CHEM_COMP WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::chem_comp_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::chem_comp_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::chem_comp_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::chem_comp_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::chem_comp_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::chem_comp_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::chem_comp_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::chem_comp_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::chem_comp_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::ChemCompList*
MMS_EntryImpl::get_chem_comp_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::ChemCompList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_chem_comp_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "CHEM_COMP", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT FORMULA,FORMULA_WEIGHT,ID,MON_NSTD_FLAG,NAME,TYPE FROM DB2INST1.CHEM_COMP WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_chem_comp_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_chem_comp_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_chem_comp_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_chem_comp_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } FORMULA;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } FORMULA_WEIGHT;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ID;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } MON_NSTD_FLAG;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[500];
    } NAME;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[80];
    } TYPE;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &FORMULA.val, 200, &FORMULA.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_chem_comp_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_DOUBLE, &FORMULA_WEIGHT.val, 0, &FORMULA_WEIGHT.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_chem_comp_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &ID.val, 10, &ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_chem_comp_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_LONG, &MON_NSTD_FLAG.val, 0, &MON_NSTD_FLAG.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_chem_comp_list()", "SQLBindCol 4");

    sqlrc = SQLBindCol( hstmt, 5, SQL_C_CHAR, &NAME.val, 500, &NAME.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_chem_comp_list()", "SQLBindCol 5");

    sqlrc = SQLBindCol( hstmt, 6, SQL_C_CHAR, &TYPE.val, 80, &TYPE.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_chem_comp_list()", "SQLBindCol 6");

    listP = new MMS::ChemCompList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_chem_comp_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].formula = CORBA::string_dup((char*)FORMULA.val);
        (*listP)[count].formula_weight = FORMULA_WEIGHT.val;
        (*listP)[count].id = CORBA::string_dup((char*)ID.val);
        (*listP)[count].mon_nstd_flag = itoa(MON_NSTD_FLAG.val);
        (*listP)[count].name = CORBA::string_dup((char*)NAME.val);
        (*listP)[count].type = CORBA::string_dup((char*)TYPE.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_chem_comp_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_chem_comp_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::chem_comp_angle_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::ChemCompAngleList*
MMS_EntryImpl::get_chem_comp_angle_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::chem_comp_atom_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::ChemCompAtomList*
MMS_EntryImpl::get_chem_comp_atom_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::chem_comp_bond_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::ChemCompBondList*
MMS_EntryImpl::get_chem_comp_bond_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::chem_comp_chir_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::ChemCompChirList*
MMS_EntryImpl::get_chem_comp_chir_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::chem_comp_chir_atom_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::ChemCompChirAtomList*
MMS_EntryImpl::get_chem_comp_chir_atom_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::chem_comp_link_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::ChemCompLinkList*
MMS_EntryImpl::get_chem_comp_link_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::chem_comp_plane_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::ChemCompPlaneList*
MMS_EntryImpl::get_chem_comp_plane_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::chem_comp_plane_atom_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::ChemCompPlaneAtomList*
MMS_EntryImpl::get_chem_comp_plane_atom_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::chem_comp_tor_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::ChemCompTorList*
MMS_EntryImpl::get_chem_comp_tor_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::chem_comp_tor_value_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::ChemCompTorValueList*
MMS_EntryImpl::get_chem_comp_tor_value_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::chem_link_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::ChemLinkList*
MMS_EntryImpl::get_chem_link_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::chem_link_angle_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::ChemLinkAngleList*
MMS_EntryImpl::get_chem_link_angle_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::chem_link_bond_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::ChemLinkBondList*
MMS_EntryImpl::get_chem_link_bond_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::chem_link_chir_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::ChemLinkChirList*
MMS_EntryImpl::get_chem_link_chir_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::chem_link_chir_atom_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::ChemLinkChirAtomList*
MMS_EntryImpl::get_chem_link_chir_atom_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::chem_link_plane_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::ChemLinkPlaneList*
MMS_EntryImpl::get_chem_link_plane_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::chem_link_plane_atom_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::ChemLinkPlaneAtomList*
MMS_EntryImpl::get_chem_link_plane_atom_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::chem_link_tor_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::ChemLinkTorList*
MMS_EntryImpl::get_chem_link_tor_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::chem_link_tor_value_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::ChemLinkTorValueList*
MMS_EntryImpl::get_chem_link_tor_value_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::entity_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.ENTITY WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::entity_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::EntityList*
MMS_EntryImpl::get_entity_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::EntityList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "ENTITY", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT DETAILS,FORMULA_WEIGHT,ID,SRC_METHOD,TYPE FROM DB2INST1.ENTITY WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[4000];
    } DETAILS;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } FORMULA_WEIGHT;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } SRC_METHOD;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[20];
    } TYPE;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &DETAILS.val, 4000, &DETAILS.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_DOUBLE, &FORMULA_WEIGHT.val, 0, &FORMULA_WEIGHT.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &ID.val, 10, &ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_CHAR, &SRC_METHOD.val, 10, &SRC_METHOD.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_list()", "SQLBindCol 4");

    sqlrc = SQLBindCol( hstmt, 5, SQL_C_CHAR, &TYPE.val, 20, &TYPE.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_list()", "SQLBindCol 5");

    listP = new MMS::EntityList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].details = CORBA::string_dup((char*)DETAILS.val);
        (*listP)[count].formula_weight = FORMULA_WEIGHT.val;
        (*listP)[count].id = CORBA::string_dup((char*)ID.val);
        (*listP)[count].src_method = CORBA::string_dup((char*)SRC_METHOD.val);
        (*listP)[count].type = CORBA::string_dup((char*)TYPE.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_entity_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::entity_keywords_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.ENTITY_KEYWORDS WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::entity_keywords_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_keywords_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_keywords_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_keywords_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_keywords_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_keywords_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_keywords_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_keywords_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_keywords_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::EntityKeywordsList*
MMS_EntryImpl::get_entity_keywords_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::EntityKeywordsList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_keywords_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "ENTITY_KEYWORDS", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT TEXT,ENTITY_ID FROM DB2INST1.ENTITY_KEYWORDS WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_keywords_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_keywords_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_keywords_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_keywords_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } TEXT;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ENTITY_ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &TEXT.val, 200, &TEXT.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_keywords_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &ENTITY_ID.val, 10, &ENTITY_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_keywords_list()", "SQLBindCol 2");

    listP = new MMS::EntityKeywordsList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_keywords_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].text = CORBA::string_dup((char*)TEXT.val);
        (*listP)[count].entity.id = CORBA::string_dup((char*)ENTITY_ID.val);
        (*listP)[count].entity.index = atoi((char*)ENTITY_ID.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_entity_keywords_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_keywords_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::entity_link_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.ENTITY_LINK WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::entity_link_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_link_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_link_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_link_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_link_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_link_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_link_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_link_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_link_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::EntityLinkList*
MMS_EntryImpl::get_entity_link_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::EntityLinkList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_link_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "ENTITY_LINK", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT DETAILS,ENTITY_ID_1,ENTITY_ID_2,ENTITY_SEQ_NUM_1,ENTITY_SEQ_NUM_2,LINK_ID FROM DB2INST1.ENTITY_LINK WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_link_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_link_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_link_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_link_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } DETAILS;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ENTITY_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ENTITY_ID_2;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } ENTITY_SEQ_NUM_1;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } ENTITY_SEQ_NUM_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } LINK_ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &DETAILS.val, 200, &DETAILS.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_link_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &ENTITY_ID_1.val, 10, &ENTITY_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_link_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &ENTITY_ID_2.val, 10, &ENTITY_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_link_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_LONG, &ENTITY_SEQ_NUM_1.val, 0, &ENTITY_SEQ_NUM_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_link_list()", "SQLBindCol 4");

    sqlrc = SQLBindCol( hstmt, 5, SQL_C_LONG, &ENTITY_SEQ_NUM_2.val, 0, &ENTITY_SEQ_NUM_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_link_list()", "SQLBindCol 5");

    sqlrc = SQLBindCol( hstmt, 6, SQL_C_CHAR, &LINK_ID.val, 10, &LINK_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_link_list()", "SQLBindCol 6");

    listP = new MMS::EntityLinkList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_link_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].details = CORBA::string_dup((char*)DETAILS.val);
        (*listP)[count].entity_id_1.id = CORBA::string_dup((char*)ENTITY_ID_1.val);
        (*listP)[count].entity_id_1.index = atoi((char*)ENTITY_ID_1.val);
        (*listP)[count].entity_id_2.id = CORBA::string_dup((char*)ENTITY_ID_2.val);
        (*listP)[count].entity_id_2.index = atoi((char*)ENTITY_ID_2.val);
        (*listP)[count].entity_seq_num_1.id = itoa(ENTITY_SEQ_NUM_1.val);
        (*listP)[count].entity_seq_num_1.index = ENTITY_SEQ_NUM_1.val;
        (*listP)[count].entity_seq_num_2.id = itoa(ENTITY_SEQ_NUM_2.val);
        (*listP)[count].entity_seq_num_2.index = ENTITY_SEQ_NUM_2.val;
        (*listP)[count].link.id = CORBA::string_dup((char*)LINK_ID.val);
        (*listP)[count].link.index = atoi((char*)LINK_ID.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_entity_link_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_link_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::entity_name_com_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.ENTITY_NAME_COM WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::entity_name_com_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_name_com_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_name_com_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_name_com_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_name_com_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_name_com_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_name_com_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_name_com_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_name_com_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::EntityNameComList*
MMS_EntryImpl::get_entity_name_com_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::EntityNameComList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_name_com_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "ENTITY_NAME_COM", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT NAME,ENTITY_ID FROM DB2INST1.ENTITY_NAME_COM WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_name_com_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_name_com_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_name_com_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_name_com_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } NAME;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ENTITY_ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &NAME.val, 200, &NAME.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_name_com_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &ENTITY_ID.val, 10, &ENTITY_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_name_com_list()", "SQLBindCol 2");

    listP = new MMS::EntityNameComList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_name_com_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].name = CORBA::string_dup((char*)NAME.val);
        (*listP)[count].entity.id = CORBA::string_dup((char*)ENTITY_ID.val);
        (*listP)[count].entity.index = atoi((char*)ENTITY_ID.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_entity_name_com_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_name_com_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::entity_name_sys_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.ENTITY_NAME_SYS WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::entity_name_sys_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_name_sys_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_name_sys_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_name_sys_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_name_sys_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_name_sys_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_name_sys_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_name_sys_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_name_sys_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::EntityNameSysList*
MMS_EntryImpl::get_entity_name_sys_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::EntityNameSysList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_name_sys_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "ENTITY_NAME_SYS", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT NAME,ENTITY_ID FROM DB2INST1.ENTITY_NAME_SYS WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_name_sys_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_name_sys_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_name_sys_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_name_sys_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } NAME;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ENTITY_ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &NAME.val, 200, &NAME.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_name_sys_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &ENTITY_ID.val, 10, &ENTITY_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_name_sys_list()", "SQLBindCol 2");

    listP = new MMS::EntityNameSysList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_name_sys_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].name = CORBA::string_dup((char*)NAME.val);
        (*listP)[count].entity.id = CORBA::string_dup((char*)ENTITY_ID.val);
        (*listP)[count].entity.index = atoi((char*)ENTITY_ID.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_entity_name_sys_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_name_sys_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::entity_poly_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.ENTITY_POLY WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::entity_poly_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_poly_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_poly_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_poly_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_poly_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_poly_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_poly_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_poly_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_poly_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::EntityPolyList*
MMS_EntryImpl::get_entity_poly_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::EntityPolyList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_poly_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "ENTITY_POLY", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT NSTD_LINKAGE,NSTD_MONOMER,NUMBER_OF_MONOMERS,TYPE,ENTITY_ID FROM DB2INST1.ENTITY_POLY WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_poly_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_poly_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_poly_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_poly_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } NSTD_LINKAGE;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } NSTD_MONOMER;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } NUMBER_OF_MONOMERS;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } TYPE;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ENTITY_ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_LONG, &NSTD_LINKAGE.val, 0, &NSTD_LINKAGE.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_poly_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_LONG, &NSTD_MONOMER.val, 0, &NSTD_MONOMER.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_poly_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_LONG, &NUMBER_OF_MONOMERS.val, 0, &NUMBER_OF_MONOMERS.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_poly_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_CHAR, &TYPE.val, 200, &TYPE.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_poly_list()", "SQLBindCol 4");

    sqlrc = SQLBindCol( hstmt, 5, SQL_C_CHAR, &ENTITY_ID.val, 10, &ENTITY_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_poly_list()", "SQLBindCol 5");

    listP = new MMS::EntityPolyList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_poly_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].nstd_linkage = itoa(NSTD_LINKAGE.val);
        (*listP)[count].nstd_monomer = itoa(NSTD_MONOMER.val);
        (*listP)[count].number_of_monomers = NUMBER_OF_MONOMERS.val;
        (*listP)[count].type = CORBA::string_dup((char*)TYPE.val);
        (*listP)[count].entity.id = CORBA::string_dup((char*)ENTITY_ID.val);
        (*listP)[count].entity.index = atoi((char*)ENTITY_ID.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_entity_poly_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_poly_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::entity_src_gen_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.ENTITY_SRC_GEN WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::entity_src_gen_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_src_gen_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_src_gen_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_src_gen_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_src_gen_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_src_gen_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_src_gen_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_src_gen_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_src_gen_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::EntitySrcGenList*
MMS_EntryImpl::get_entity_src_gen_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::EntitySrcGenList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_gen_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "ENTITY_SRC_GEN", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT GENE_SRC_COMMON_NAME,GENE_SRC_GENUS,GENE_SRC_SPECIES,GENE_SRC_STRAIN,GENE_SRC_TISSUE,GENE_SRC_TISSUE_FRACTION,HOST_ORG_COMMON_NAME,HOST_ORG_GENUS,HOST_ORG_SPECIES,PLASMID_DETAILS,PLASMID_NAME,ENTITY_ID FROM DB2INST1.ENTITY_SRC_GEN WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_gen_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_gen_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_gen_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_gen_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } GENE_SRC_COMMON_NAME;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } GENE_SRC_GENUS;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } GENE_SRC_SPECIES;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } GENE_SRC_STRAIN;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } GENE_SRC_TISSUE;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } GENE_SRC_TISSUE_FRACTION;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } HOST_ORG_COMMON_NAME;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } HOST_ORG_GENUS;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } HOST_ORG_SPECIES;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } PLASMID_DETAILS;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } PLASMID_NAME;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ENTITY_ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &GENE_SRC_COMMON_NAME.val, 200, &GENE_SRC_COMMON_NAME.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_gen_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &GENE_SRC_GENUS.val, 200, &GENE_SRC_GENUS.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_gen_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &GENE_SRC_SPECIES.val, 200, &GENE_SRC_SPECIES.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_gen_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_CHAR, &GENE_SRC_STRAIN.val, 200, &GENE_SRC_STRAIN.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_gen_list()", "SQLBindCol 4");

    sqlrc = SQLBindCol( hstmt, 5, SQL_C_CHAR, &GENE_SRC_TISSUE.val, 200, &GENE_SRC_TISSUE.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_gen_list()", "SQLBindCol 5");

    sqlrc = SQLBindCol( hstmt, 6, SQL_C_CHAR, &GENE_SRC_TISSUE_FRACTION.val, 200, &GENE_SRC_TISSUE_FRACTION.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_gen_list()", "SQLBindCol 6");

    sqlrc = SQLBindCol( hstmt, 7, SQL_C_CHAR, &HOST_ORG_COMMON_NAME.val, 200, &HOST_ORG_COMMON_NAME.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_gen_list()", "SQLBindCol 7");

    sqlrc = SQLBindCol( hstmt, 8, SQL_C_CHAR, &HOST_ORG_GENUS.val, 200, &HOST_ORG_GENUS.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_gen_list()", "SQLBindCol 8");

    sqlrc = SQLBindCol( hstmt, 9, SQL_C_CHAR, &HOST_ORG_SPECIES.val, 200, &HOST_ORG_SPECIES.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_gen_list()", "SQLBindCol 9");

    sqlrc = SQLBindCol( hstmt, 10, SQL_C_CHAR, &PLASMID_DETAILS.val, 200, &PLASMID_DETAILS.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_gen_list()", "SQLBindCol 10");

    sqlrc = SQLBindCol( hstmt, 11, SQL_C_CHAR, &PLASMID_NAME.val, 200, &PLASMID_NAME.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_gen_list()", "SQLBindCol 11");

    sqlrc = SQLBindCol( hstmt, 12, SQL_C_CHAR, &ENTITY_ID.val, 10, &ENTITY_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_gen_list()", "SQLBindCol 12");

    listP = new MMS::EntitySrcGenList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_gen_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].gene_src_common_name = CORBA::string_dup((char*)GENE_SRC_COMMON_NAME.val);
        (*listP)[count].gene_src_genus = CORBA::string_dup((char*)GENE_SRC_GENUS.val);
        (*listP)[count].gene_src_species = CORBA::string_dup((char*)GENE_SRC_SPECIES.val);
        (*listP)[count].gene_src_strain = CORBA::string_dup((char*)GENE_SRC_STRAIN.val);
        (*listP)[count].gene_src_tissue = CORBA::string_dup((char*)GENE_SRC_TISSUE.val);
        (*listP)[count].gene_src_tissue_fraction = CORBA::string_dup((char*)GENE_SRC_TISSUE_FRACTION.val);
        (*listP)[count].host_org_common_name = CORBA::string_dup((char*)HOST_ORG_COMMON_NAME.val);
        (*listP)[count].host_org_genus = CORBA::string_dup((char*)HOST_ORG_GENUS.val);
        (*listP)[count].host_org_species = CORBA::string_dup((char*)HOST_ORG_SPECIES.val);
        (*listP)[count].plasmid_details = CORBA::string_dup((char*)PLASMID_DETAILS.val);
        (*listP)[count].plasmid_name = CORBA::string_dup((char*)PLASMID_NAME.val);
        (*listP)[count].entity.id = CORBA::string_dup((char*)ENTITY_ID.val);
        (*listP)[count].entity.index = atoi((char*)ENTITY_ID.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_gen_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_gen_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::entity_src_nat_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.ENTITY_SRC_NAT WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::entity_src_nat_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_src_nat_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_src_nat_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_src_nat_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_src_nat_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_src_nat_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_src_nat_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_src_nat_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::entity_src_nat_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::EntitySrcNatList*
MMS_EntryImpl::get_entity_src_nat_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::EntitySrcNatList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_nat_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "ENTITY_SRC_NAT", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT COMMON_NAME,DETAILS,GENUS,SPECIES,STRAIN,TISSUE,TISSUE_FRACTION,ENTITY_ID FROM DB2INST1.ENTITY_SRC_NAT WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_nat_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_nat_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_nat_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_nat_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } COMMON_NAME;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[500];
    } DETAILS;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } GENUS;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } SPECIES;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } STRAIN;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } TISSUE;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } TISSUE_FRACTION;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ENTITY_ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &COMMON_NAME.val, 200, &COMMON_NAME.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_nat_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &DETAILS.val, 500, &DETAILS.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_nat_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &GENUS.val, 200, &GENUS.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_nat_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_CHAR, &SPECIES.val, 200, &SPECIES.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_nat_list()", "SQLBindCol 4");

    sqlrc = SQLBindCol( hstmt, 5, SQL_C_CHAR, &STRAIN.val, 200, &STRAIN.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_nat_list()", "SQLBindCol 5");

    sqlrc = SQLBindCol( hstmt, 6, SQL_C_CHAR, &TISSUE.val, 200, &TISSUE.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_nat_list()", "SQLBindCol 6");

    sqlrc = SQLBindCol( hstmt, 7, SQL_C_CHAR, &TISSUE_FRACTION.val, 200, &TISSUE_FRACTION.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_nat_list()", "SQLBindCol 7");

    sqlrc = SQLBindCol( hstmt, 8, SQL_C_CHAR, &ENTITY_ID.val, 10, &ENTITY_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_nat_list()", "SQLBindCol 8");

    listP = new MMS::EntitySrcNatList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_nat_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].common_name = CORBA::string_dup((char*)COMMON_NAME.val);
        (*listP)[count].details = CORBA::string_dup((char*)DETAILS.val);
        (*listP)[count].genus = CORBA::string_dup((char*)GENUS.val);
        (*listP)[count].species = CORBA::string_dup((char*)SPECIES.val);
        (*listP)[count].strain = CORBA::string_dup((char*)STRAIN.val);
        (*listP)[count].tissue = CORBA::string_dup((char*)TISSUE.val);
        (*listP)[count].tissue_fraction = CORBA::string_dup((char*)TISSUE_FRACTION.val);
        (*listP)[count].entity.id = CORBA::string_dup((char*)ENTITY_ID.val);
        (*listP)[count].entity.index = atoi((char*)ENTITY_ID.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_nat_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_entity_src_nat_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::entry_link_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::EntryLinkList*
MMS_EntryImpl::get_entry_link_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::geom_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::GeomList*
MMS_EntryImpl::get_geom_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::geom_angle_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.GEOM_ANGLE WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::geom_angle_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_angle_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_angle_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_angle_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_angle_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_angle_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_angle_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_angle_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_angle_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::GeomAngleList*
MMS_EntryImpl::get_geom_angle_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::GeomAngleList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "GEOM_ANGLE", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT SITE_SYMMETRY_1,SITE_SYMMETRY_2,SITE_SYMMETRY_3,VALUE,VALUE_ESD,ATOM_SITE_ID_1,ATOM_SITE_ID_2,ATOM_SITE_ID_3,ATOM_SITE_AUTH_ASYM_ID_1,ATOM_SITE_AUTH_ATOM_ID_1,ATOM_SITE_AUTH_COMP_ID_1,ATOM_SITE_AUTH_SEQ_ID_1,ATOM_SITE_AUTH_ASYM_ID_2,ATOM_SITE_AUTH_ATOM_ID_2,ATOM_SITE_AUTH_COMP_ID_2,ATOM_SITE_AUTH_SEQ_ID_2,ATOM_SITE_AUTH_ASYM_ID_3,ATOM_SITE_AUTH_ATOM_ID_3,ATOM_SITE_AUTH_COMP_ID_3,ATOM_SITE_AUTH_SEQ_ID_3,ATOM_SITE_LABEL_ALT_ID_1,ATOM_SITE_LABEL_ASYM_ID_1,ATOM_SITE_LABEL_ATOM_ID_1,ATOM_SITE_LABEL_COMP_ID_1,ATOM_SITE_LABEL_SEQ_ID_1,ATOM_SITE_LABEL_ALT_ID_2,ATOM_SITE_LABEL_ASYM_ID_2,ATOM_SITE_LABEL_ATOM_ID_2,ATOM_SITE_LABEL_COMP_ID_2,ATOM_SITE_LABEL_SEQ_ID_2,ATOM_SITE_LABEL_ALT_ID_3,ATOM_SITE_LABEL_ASYM_ID_3,ATOM_SITE_LABEL_ATOM_ID_3,ATOM_SITE_LABEL_COMP_ID_3,ATOM_SITE_LABEL_SEQ_ID_3 FROM DB2INST1.GEOM_ANGLE WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } SITE_SYMMETRY_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } SITE_SYMMETRY_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } SITE_SYMMETRY_3;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } VALUE;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } VALUE_ESD;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_ID_3;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_ASYM_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } ATOM_SITE_AUTH_ATOM_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_COMP_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_SEQ_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_ASYM_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } ATOM_SITE_AUTH_ATOM_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_COMP_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_SEQ_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_ASYM_ID_3;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } ATOM_SITE_AUTH_ATOM_ID_3;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_COMP_ID_3;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_SEQ_ID_3;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_ALT_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_ASYM_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } ATOM_SITE_LABEL_ATOM_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_COMP_ID_1;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } ATOM_SITE_LABEL_SEQ_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_ALT_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_ASYM_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } ATOM_SITE_LABEL_ATOM_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_COMP_ID_2;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } ATOM_SITE_LABEL_SEQ_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_ALT_ID_3;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_ASYM_ID_3;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } ATOM_SITE_LABEL_ATOM_ID_3;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_COMP_ID_3;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } ATOM_SITE_LABEL_SEQ_ID_3;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &SITE_SYMMETRY_1.val, 10, &SITE_SYMMETRY_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &SITE_SYMMETRY_2.val, 10, &SITE_SYMMETRY_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &SITE_SYMMETRY_3.val, 10, &SITE_SYMMETRY_3.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_DOUBLE, &VALUE.val, 0, &VALUE.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 4");

    sqlrc = SQLBindCol( hstmt, 5, SQL_C_DOUBLE, &VALUE_ESD.val, 0, &VALUE_ESD.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 5");

    sqlrc = SQLBindCol( hstmt, 6, SQL_C_CHAR, &ATOM_SITE_ID_1.val, 10, &ATOM_SITE_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 6");

    sqlrc = SQLBindCol( hstmt, 7, SQL_C_CHAR, &ATOM_SITE_ID_2.val, 10, &ATOM_SITE_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 7");

    sqlrc = SQLBindCol( hstmt, 8, SQL_C_CHAR, &ATOM_SITE_ID_3.val, 10, &ATOM_SITE_ID_3.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 8");

    sqlrc = SQLBindCol( hstmt, 9, SQL_C_CHAR, &ATOM_SITE_AUTH_ASYM_ID_1.val, 10, &ATOM_SITE_AUTH_ASYM_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 9");

    sqlrc = SQLBindCol( hstmt, 10, SQL_C_CHAR, &ATOM_SITE_AUTH_ATOM_ID_1.val, 6, &ATOM_SITE_AUTH_ATOM_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 10");

    sqlrc = SQLBindCol( hstmt, 11, SQL_C_CHAR, &ATOM_SITE_AUTH_COMP_ID_1.val, 10, &ATOM_SITE_AUTH_COMP_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 11");

    sqlrc = SQLBindCol( hstmt, 12, SQL_C_CHAR, &ATOM_SITE_AUTH_SEQ_ID_1.val, 10, &ATOM_SITE_AUTH_SEQ_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 12");

    sqlrc = SQLBindCol( hstmt, 13, SQL_C_CHAR, &ATOM_SITE_AUTH_ASYM_ID_2.val, 10, &ATOM_SITE_AUTH_ASYM_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 13");

    sqlrc = SQLBindCol( hstmt, 14, SQL_C_CHAR, &ATOM_SITE_AUTH_ATOM_ID_2.val, 6, &ATOM_SITE_AUTH_ATOM_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 14");

    sqlrc = SQLBindCol( hstmt, 15, SQL_C_CHAR, &ATOM_SITE_AUTH_COMP_ID_2.val, 10, &ATOM_SITE_AUTH_COMP_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 15");

    sqlrc = SQLBindCol( hstmt, 16, SQL_C_CHAR, &ATOM_SITE_AUTH_SEQ_ID_2.val, 10, &ATOM_SITE_AUTH_SEQ_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 16");

    sqlrc = SQLBindCol( hstmt, 17, SQL_C_CHAR, &ATOM_SITE_AUTH_ASYM_ID_3.val, 10, &ATOM_SITE_AUTH_ASYM_ID_3.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 17");

    sqlrc = SQLBindCol( hstmt, 18, SQL_C_CHAR, &ATOM_SITE_AUTH_ATOM_ID_3.val, 6, &ATOM_SITE_AUTH_ATOM_ID_3.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 18");

    sqlrc = SQLBindCol( hstmt, 19, SQL_C_CHAR, &ATOM_SITE_AUTH_COMP_ID_3.val, 10, &ATOM_SITE_AUTH_COMP_ID_3.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 19");

    sqlrc = SQLBindCol( hstmt, 20, SQL_C_CHAR, &ATOM_SITE_AUTH_SEQ_ID_3.val, 10, &ATOM_SITE_AUTH_SEQ_ID_3.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 20");

    sqlrc = SQLBindCol( hstmt, 21, SQL_C_CHAR, &ATOM_SITE_LABEL_ALT_ID_1.val, 10, &ATOM_SITE_LABEL_ALT_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 21");

    sqlrc = SQLBindCol( hstmt, 22, SQL_C_CHAR, &ATOM_SITE_LABEL_ASYM_ID_1.val, 10, &ATOM_SITE_LABEL_ASYM_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 22");

    sqlrc = SQLBindCol( hstmt, 23, SQL_C_CHAR, &ATOM_SITE_LABEL_ATOM_ID_1.val, 6, &ATOM_SITE_LABEL_ATOM_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 23");

    sqlrc = SQLBindCol( hstmt, 24, SQL_C_CHAR, &ATOM_SITE_LABEL_COMP_ID_1.val, 10, &ATOM_SITE_LABEL_COMP_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 24");

    sqlrc = SQLBindCol( hstmt, 25, SQL_C_LONG, &ATOM_SITE_LABEL_SEQ_ID_1.val, 0, &ATOM_SITE_LABEL_SEQ_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 25");

    sqlrc = SQLBindCol( hstmt, 26, SQL_C_CHAR, &ATOM_SITE_LABEL_ALT_ID_2.val, 10, &ATOM_SITE_LABEL_ALT_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 26");

    sqlrc = SQLBindCol( hstmt, 27, SQL_C_CHAR, &ATOM_SITE_LABEL_ASYM_ID_2.val, 10, &ATOM_SITE_LABEL_ASYM_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 27");

    sqlrc = SQLBindCol( hstmt, 28, SQL_C_CHAR, &ATOM_SITE_LABEL_ATOM_ID_2.val, 6, &ATOM_SITE_LABEL_ATOM_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 28");

    sqlrc = SQLBindCol( hstmt, 29, SQL_C_CHAR, &ATOM_SITE_LABEL_COMP_ID_2.val, 10, &ATOM_SITE_LABEL_COMP_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 29");

    sqlrc = SQLBindCol( hstmt, 30, SQL_C_LONG, &ATOM_SITE_LABEL_SEQ_ID_2.val, 0, &ATOM_SITE_LABEL_SEQ_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 30");

    sqlrc = SQLBindCol( hstmt, 31, SQL_C_CHAR, &ATOM_SITE_LABEL_ALT_ID_3.val, 10, &ATOM_SITE_LABEL_ALT_ID_3.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 31");

    sqlrc = SQLBindCol( hstmt, 32, SQL_C_CHAR, &ATOM_SITE_LABEL_ASYM_ID_3.val, 10, &ATOM_SITE_LABEL_ASYM_ID_3.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 32");

    sqlrc = SQLBindCol( hstmt, 33, SQL_C_CHAR, &ATOM_SITE_LABEL_ATOM_ID_3.val, 6, &ATOM_SITE_LABEL_ATOM_ID_3.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 33");

    sqlrc = SQLBindCol( hstmt, 34, SQL_C_CHAR, &ATOM_SITE_LABEL_COMP_ID_3.val, 10, &ATOM_SITE_LABEL_COMP_ID_3.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 34");

    sqlrc = SQLBindCol( hstmt, 35, SQL_C_LONG, &ATOM_SITE_LABEL_SEQ_ID_3.val, 0, &ATOM_SITE_LABEL_SEQ_ID_3.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLBindCol 35");

    listP = new MMS::GeomAngleList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].site_symmetry_1 = CORBA::string_dup((char*)SITE_SYMMETRY_1.val);
        (*listP)[count].site_symmetry_2 = CORBA::string_dup((char*)SITE_SYMMETRY_2.val);
        (*listP)[count].site_symmetry_3 = CORBA::string_dup((char*)SITE_SYMMETRY_3.val);
        (*listP)[count].value = VALUE.val;
        (*listP)[count].value_esd = VALUE_ESD.val;
        (*listP)[count].atom_site_id_1.id = CORBA::string_dup((char*)ATOM_SITE_ID_1.val);
        (*listP)[count].atom_site_id_1.index = atoi((char*)ATOM_SITE_ID_1.val);
        (*listP)[count].atom_site_id_2.id = CORBA::string_dup((char*)ATOM_SITE_ID_2.val);
        (*listP)[count].atom_site_id_2.index = atoi((char*)ATOM_SITE_ID_2.val);
        (*listP)[count].atom_site_id_3.id = CORBA::string_dup((char*)ATOM_SITE_ID_3.val);
        (*listP)[count].atom_site_id_3.index = atoi((char*)ATOM_SITE_ID_3.val);
        (*listP)[count].atom_site_auth_1.atom.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_ATOM_ID_1.val);
        (*listP)[count].atom_site_auth_1.atom.index = atoi((char*)ATOM_SITE_AUTH_ATOM_ID_1.val);
        (*listP)[count].atom_site_auth_1.asym.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_ASYM_ID_1.val);
        (*listP)[count].atom_site_auth_1.asym.index = atoi((char*)ATOM_SITE_AUTH_ASYM_ID_1.val);
        (*listP)[count].atom_site_auth_1.comp.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_COMP_ID_1.val);
        (*listP)[count].atom_site_auth_1.comp.index = atoi((char*)ATOM_SITE_AUTH_COMP_ID_1.val);
        (*listP)[count].atom_site_auth_1.seq.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_SEQ_ID_1.val);
        (*listP)[count].atom_site_auth_1.seq.index = atoi((char*)ATOM_SITE_AUTH_SEQ_ID_1.val);
        (*listP)[count].atom_site_auth_2.atom.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_ATOM_ID_2.val);
        (*listP)[count].atom_site_auth_2.atom.index = atoi((char*)ATOM_SITE_AUTH_ATOM_ID_2.val);
        (*listP)[count].atom_site_auth_2.asym.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_ASYM_ID_2.val);
        (*listP)[count].atom_site_auth_2.asym.index = atoi((char*)ATOM_SITE_AUTH_ASYM_ID_2.val);
        (*listP)[count].atom_site_auth_2.comp.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_COMP_ID_2.val);
        (*listP)[count].atom_site_auth_2.comp.index = atoi((char*)ATOM_SITE_AUTH_COMP_ID_2.val);
        (*listP)[count].atom_site_auth_2.seq.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_SEQ_ID_2.val);
        (*listP)[count].atom_site_auth_2.seq.index = atoi((char*)ATOM_SITE_AUTH_SEQ_ID_2.val);
        (*listP)[count].atom_site_auth_3.atom.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_ATOM_ID_3.val);
        (*listP)[count].atom_site_auth_3.atom.index = atoi((char*)ATOM_SITE_AUTH_ATOM_ID_3.val);
        (*listP)[count].atom_site_auth_3.asym.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_ASYM_ID_3.val);
        (*listP)[count].atom_site_auth_3.asym.index = atoi((char*)ATOM_SITE_AUTH_ASYM_ID_3.val);
        (*listP)[count].atom_site_auth_3.comp.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_COMP_ID_3.val);
        (*listP)[count].atom_site_auth_3.comp.index = atoi((char*)ATOM_SITE_AUTH_COMP_ID_3.val);
        (*listP)[count].atom_site_auth_3.seq.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_SEQ_ID_3.val);
        (*listP)[count].atom_site_auth_3.seq.index = atoi((char*)ATOM_SITE_AUTH_SEQ_ID_3.val);
        (*listP)[count].atom_site_label_1.atom.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ATOM_ID_1.val);
        (*listP)[count].atom_site_label_1.atom.index = atoi((char*)ATOM_SITE_LABEL_ATOM_ID_1.val);
        (*listP)[count].atom_site_label_1.alt.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ALT_ID_1.val);
        (*listP)[count].atom_site_label_1.alt.index = atoi((char*)ATOM_SITE_LABEL_ALT_ID_1.val);
        (*listP)[count].atom_site_label_1.asym.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ASYM_ID_1.val);
        (*listP)[count].atom_site_label_1.asym.index = atoi((char*)ATOM_SITE_LABEL_ASYM_ID_1.val);
        (*listP)[count].atom_site_label_1.comp.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_COMP_ID_1.val);
        (*listP)[count].atom_site_label_1.comp.index = atoi((char*)ATOM_SITE_LABEL_COMP_ID_1.val);
        (*listP)[count].atom_site_label_1.seq.id = itoa(ATOM_SITE_LABEL_SEQ_ID_1.val);
        (*listP)[count].atom_site_label_1.seq.index = ATOM_SITE_LABEL_SEQ_ID_1.val;
        (*listP)[count].atom_site_label_2.atom.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ATOM_ID_2.val);
        (*listP)[count].atom_site_label_2.atom.index = atoi((char*)ATOM_SITE_LABEL_ATOM_ID_2.val);
        (*listP)[count].atom_site_label_2.alt.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ALT_ID_2.val);
        (*listP)[count].atom_site_label_2.alt.index = atoi((char*)ATOM_SITE_LABEL_ALT_ID_2.val);
        (*listP)[count].atom_site_label_2.asym.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ASYM_ID_2.val);
        (*listP)[count].atom_site_label_2.asym.index = atoi((char*)ATOM_SITE_LABEL_ASYM_ID_2.val);
        (*listP)[count].atom_site_label_2.comp.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_COMP_ID_2.val);
        (*listP)[count].atom_site_label_2.comp.index = atoi((char*)ATOM_SITE_LABEL_COMP_ID_2.val);
        (*listP)[count].atom_site_label_2.seq.id = itoa(ATOM_SITE_LABEL_SEQ_ID_2.val);
        (*listP)[count].atom_site_label_2.seq.index = ATOM_SITE_LABEL_SEQ_ID_2.val;
        (*listP)[count].atom_site_label_3.atom.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ATOM_ID_3.val);
        (*listP)[count].atom_site_label_3.atom.index = atoi((char*)ATOM_SITE_LABEL_ATOM_ID_3.val);
        (*listP)[count].atom_site_label_3.alt.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ALT_ID_3.val);
        (*listP)[count].atom_site_label_3.alt.index = atoi((char*)ATOM_SITE_LABEL_ALT_ID_3.val);
        (*listP)[count].atom_site_label_3.asym.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ASYM_ID_3.val);
        (*listP)[count].atom_site_label_3.asym.index = atoi((char*)ATOM_SITE_LABEL_ASYM_ID_3.val);
        (*listP)[count].atom_site_label_3.comp.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_COMP_ID_3.val);
        (*listP)[count].atom_site_label_3.comp.index = atoi((char*)ATOM_SITE_LABEL_COMP_ID_3.val);
        (*listP)[count].atom_site_label_3.seq.id = itoa(ATOM_SITE_LABEL_SEQ_ID_3.val);
        (*listP)[count].atom_site_label_3.seq.index = ATOM_SITE_LABEL_SEQ_ID_3.val;

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_angle_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::geom_bond_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.GEOM_BOND WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::geom_bond_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_bond_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_bond_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_bond_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_bond_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_bond_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_bond_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_bond_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_bond_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::GeomBondList*
MMS_EntryImpl::get_geom_bond_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::GeomBondList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "GEOM_BOND", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT DIST,DIST_ESD,SITE_SYMMETRY_1,SITE_SYMMETRY_2,ATOM_SITE_ID_1,ATOM_SITE_ID_2,ATOM_SITE_AUTH_ASYM_ID_1,ATOM_SITE_AUTH_ATOM_ID_1,ATOM_SITE_AUTH_COMP_ID_1,ATOM_SITE_AUTH_SEQ_ID_1,ATOM_SITE_AUTH_ASYM_ID_2,ATOM_SITE_AUTH_ATOM_ID_2,ATOM_SITE_AUTH_COMP_ID_2,ATOM_SITE_AUTH_SEQ_ID_2,ATOM_SITE_LABEL_ALT_ID_1,ATOM_SITE_LABEL_ASYM_ID_1,ATOM_SITE_LABEL_ATOM_ID_1,ATOM_SITE_LABEL_COMP_ID_1,ATOM_SITE_LABEL_SEQ_ID_1,ATOM_SITE_LABEL_ALT_ID_2,ATOM_SITE_LABEL_ASYM_ID_2,ATOM_SITE_LABEL_ATOM_ID_2,ATOM_SITE_LABEL_COMP_ID_2,ATOM_SITE_LABEL_SEQ_ID_2 FROM DB2INST1.GEOM_BOND WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } DIST;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } DIST_ESD;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } SITE_SYMMETRY_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } SITE_SYMMETRY_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_ASYM_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } ATOM_SITE_AUTH_ATOM_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_COMP_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_SEQ_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_ASYM_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } ATOM_SITE_AUTH_ATOM_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_COMP_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_SEQ_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_ALT_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_ASYM_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } ATOM_SITE_LABEL_ATOM_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_COMP_ID_1;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } ATOM_SITE_LABEL_SEQ_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_ALT_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_ASYM_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } ATOM_SITE_LABEL_ATOM_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_COMP_ID_2;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } ATOM_SITE_LABEL_SEQ_ID_2;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_DOUBLE, &DIST.val, 0, &DIST.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_DOUBLE, &DIST_ESD.val, 0, &DIST_ESD.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &SITE_SYMMETRY_1.val, 10, &SITE_SYMMETRY_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_CHAR, &SITE_SYMMETRY_2.val, 10, &SITE_SYMMETRY_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 4");

    sqlrc = SQLBindCol( hstmt, 5, SQL_C_CHAR, &ATOM_SITE_ID_1.val, 10, &ATOM_SITE_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 5");

    sqlrc = SQLBindCol( hstmt, 6, SQL_C_CHAR, &ATOM_SITE_ID_2.val, 10, &ATOM_SITE_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 6");

    sqlrc = SQLBindCol( hstmt, 7, SQL_C_CHAR, &ATOM_SITE_AUTH_ASYM_ID_1.val, 10, &ATOM_SITE_AUTH_ASYM_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 7");

    sqlrc = SQLBindCol( hstmt, 8, SQL_C_CHAR, &ATOM_SITE_AUTH_ATOM_ID_1.val, 6, &ATOM_SITE_AUTH_ATOM_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 8");

    sqlrc = SQLBindCol( hstmt, 9, SQL_C_CHAR, &ATOM_SITE_AUTH_COMP_ID_1.val, 10, &ATOM_SITE_AUTH_COMP_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 9");

    sqlrc = SQLBindCol( hstmt, 10, SQL_C_CHAR, &ATOM_SITE_AUTH_SEQ_ID_1.val, 10, &ATOM_SITE_AUTH_SEQ_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 10");

    sqlrc = SQLBindCol( hstmt, 11, SQL_C_CHAR, &ATOM_SITE_AUTH_ASYM_ID_2.val, 10, &ATOM_SITE_AUTH_ASYM_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 11");

    sqlrc = SQLBindCol( hstmt, 12, SQL_C_CHAR, &ATOM_SITE_AUTH_ATOM_ID_2.val, 6, &ATOM_SITE_AUTH_ATOM_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 12");

    sqlrc = SQLBindCol( hstmt, 13, SQL_C_CHAR, &ATOM_SITE_AUTH_COMP_ID_2.val, 10, &ATOM_SITE_AUTH_COMP_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 13");

    sqlrc = SQLBindCol( hstmt, 14, SQL_C_CHAR, &ATOM_SITE_AUTH_SEQ_ID_2.val, 10, &ATOM_SITE_AUTH_SEQ_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 14");

    sqlrc = SQLBindCol( hstmt, 15, SQL_C_CHAR, &ATOM_SITE_LABEL_ALT_ID_1.val, 10, &ATOM_SITE_LABEL_ALT_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 15");

    sqlrc = SQLBindCol( hstmt, 16, SQL_C_CHAR, &ATOM_SITE_LABEL_ASYM_ID_1.val, 10, &ATOM_SITE_LABEL_ASYM_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 16");

    sqlrc = SQLBindCol( hstmt, 17, SQL_C_CHAR, &ATOM_SITE_LABEL_ATOM_ID_1.val, 6, &ATOM_SITE_LABEL_ATOM_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 17");

    sqlrc = SQLBindCol( hstmt, 18, SQL_C_CHAR, &ATOM_SITE_LABEL_COMP_ID_1.val, 10, &ATOM_SITE_LABEL_COMP_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 18");

    sqlrc = SQLBindCol( hstmt, 19, SQL_C_LONG, &ATOM_SITE_LABEL_SEQ_ID_1.val, 0, &ATOM_SITE_LABEL_SEQ_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 19");

    sqlrc = SQLBindCol( hstmt, 20, SQL_C_CHAR, &ATOM_SITE_LABEL_ALT_ID_2.val, 10, &ATOM_SITE_LABEL_ALT_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 20");

    sqlrc = SQLBindCol( hstmt, 21, SQL_C_CHAR, &ATOM_SITE_LABEL_ASYM_ID_2.val, 10, &ATOM_SITE_LABEL_ASYM_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 21");

    sqlrc = SQLBindCol( hstmt, 22, SQL_C_CHAR, &ATOM_SITE_LABEL_ATOM_ID_2.val, 6, &ATOM_SITE_LABEL_ATOM_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 22");

    sqlrc = SQLBindCol( hstmt, 23, SQL_C_CHAR, &ATOM_SITE_LABEL_COMP_ID_2.val, 10, &ATOM_SITE_LABEL_COMP_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 23");

    sqlrc = SQLBindCol( hstmt, 24, SQL_C_LONG, &ATOM_SITE_LABEL_SEQ_ID_2.val, 0, &ATOM_SITE_LABEL_SEQ_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLBindCol 24");

    listP = new MMS::GeomBondList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].dist = DIST.val;
        (*listP)[count].dist_esd = DIST_ESD.val;
        (*listP)[count].site_symmetry_1 = CORBA::string_dup((char*)SITE_SYMMETRY_1.val);
        (*listP)[count].site_symmetry_2 = CORBA::string_dup((char*)SITE_SYMMETRY_2.val);
        (*listP)[count].atom_site_id_1.id = CORBA::string_dup((char*)ATOM_SITE_ID_1.val);
        (*listP)[count].atom_site_id_1.index = atoi((char*)ATOM_SITE_ID_1.val);
        (*listP)[count].atom_site_id_2.id = CORBA::string_dup((char*)ATOM_SITE_ID_2.val);
        (*listP)[count].atom_site_id_2.index = atoi((char*)ATOM_SITE_ID_2.val);
        (*listP)[count].atom_site_auth_1.atom.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_ATOM_ID_1.val);
        (*listP)[count].atom_site_auth_1.atom.index = atoi((char*)ATOM_SITE_AUTH_ATOM_ID_1.val);
        (*listP)[count].atom_site_auth_1.asym.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_ASYM_ID_1.val);
        (*listP)[count].atom_site_auth_1.asym.index = atoi((char*)ATOM_SITE_AUTH_ASYM_ID_1.val);
        (*listP)[count].atom_site_auth_1.comp.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_COMP_ID_1.val);
        (*listP)[count].atom_site_auth_1.comp.index = atoi((char*)ATOM_SITE_AUTH_COMP_ID_1.val);
        (*listP)[count].atom_site_auth_1.seq.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_SEQ_ID_1.val);
        (*listP)[count].atom_site_auth_1.seq.index = atoi((char*)ATOM_SITE_AUTH_SEQ_ID_1.val);
        (*listP)[count].atom_site_auth_2.atom.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_ATOM_ID_2.val);
        (*listP)[count].atom_site_auth_2.atom.index = atoi((char*)ATOM_SITE_AUTH_ATOM_ID_2.val);
        (*listP)[count].atom_site_auth_2.asym.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_ASYM_ID_2.val);
        (*listP)[count].atom_site_auth_2.asym.index = atoi((char*)ATOM_SITE_AUTH_ASYM_ID_2.val);
        (*listP)[count].atom_site_auth_2.comp.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_COMP_ID_2.val);
        (*listP)[count].atom_site_auth_2.comp.index = atoi((char*)ATOM_SITE_AUTH_COMP_ID_2.val);
        (*listP)[count].atom_site_auth_2.seq.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_SEQ_ID_2.val);
        (*listP)[count].atom_site_auth_2.seq.index = atoi((char*)ATOM_SITE_AUTH_SEQ_ID_2.val);
        (*listP)[count].atom_site_label_1.atom.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ATOM_ID_1.val);
        (*listP)[count].atom_site_label_1.atom.index = atoi((char*)ATOM_SITE_LABEL_ATOM_ID_1.val);
        (*listP)[count].atom_site_label_1.alt.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ALT_ID_1.val);
        (*listP)[count].atom_site_label_1.alt.index = atoi((char*)ATOM_SITE_LABEL_ALT_ID_1.val);
        (*listP)[count].atom_site_label_1.asym.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ASYM_ID_1.val);
        (*listP)[count].atom_site_label_1.asym.index = atoi((char*)ATOM_SITE_LABEL_ASYM_ID_1.val);
        (*listP)[count].atom_site_label_1.comp.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_COMP_ID_1.val);
        (*listP)[count].atom_site_label_1.comp.index = atoi((char*)ATOM_SITE_LABEL_COMP_ID_1.val);
        (*listP)[count].atom_site_label_1.seq.id = itoa(ATOM_SITE_LABEL_SEQ_ID_1.val);
        (*listP)[count].atom_site_label_1.seq.index = ATOM_SITE_LABEL_SEQ_ID_1.val;
        (*listP)[count].atom_site_label_2.atom.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ATOM_ID_2.val);
        (*listP)[count].atom_site_label_2.atom.index = atoi((char*)ATOM_SITE_LABEL_ATOM_ID_2.val);
        (*listP)[count].atom_site_label_2.alt.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ALT_ID_2.val);
        (*listP)[count].atom_site_label_2.alt.index = atoi((char*)ATOM_SITE_LABEL_ALT_ID_2.val);
        (*listP)[count].atom_site_label_2.asym.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ASYM_ID_2.val);
        (*listP)[count].atom_site_label_2.asym.index = atoi((char*)ATOM_SITE_LABEL_ASYM_ID_2.val);
        (*listP)[count].atom_site_label_2.comp.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_COMP_ID_2.val);
        (*listP)[count].atom_site_label_2.comp.index = atoi((char*)ATOM_SITE_LABEL_COMP_ID_2.val);
        (*listP)[count].atom_site_label_2.seq.id = itoa(ATOM_SITE_LABEL_SEQ_ID_2.val);
        (*listP)[count].atom_site_label_2.seq.index = ATOM_SITE_LABEL_SEQ_ID_2.val;

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_bond_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::geom_contact_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.GEOM_CONTACT WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::geom_contact_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_contact_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_contact_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_contact_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_contact_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_contact_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_contact_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_contact_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_contact_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::GeomContactList*
MMS_EntryImpl::get_geom_contact_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::GeomContactList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "GEOM_CONTACT", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT DIST,DIST_ESD,SITE_SYMMETRY_1,SITE_SYMMETRY_2,ATOM_SITE_ID_1,ATOM_SITE_ID_2,ATOM_SITE_AUTH_ASYM_ID_1,ATOM_SITE_AUTH_ATOM_ID_1,ATOM_SITE_AUTH_COMP_ID_1,ATOM_SITE_AUTH_SEQ_ID_1,ATOM_SITE_AUTH_ASYM_ID_2,ATOM_SITE_AUTH_ATOM_ID_2,ATOM_SITE_AUTH_COMP_ID_2,ATOM_SITE_AUTH_SEQ_ID_2,ATOM_SITE_LABEL_ALT_ID_1,ATOM_SITE_LABEL_ASYM_ID_1,ATOM_SITE_LABEL_ATOM_ID_1,ATOM_SITE_LABEL_COMP_ID_1,ATOM_SITE_LABEL_SEQ_ID_1,ATOM_SITE_LABEL_ALT_ID_2,ATOM_SITE_LABEL_ASYM_ID_2,ATOM_SITE_LABEL_ATOM_ID_2,ATOM_SITE_LABEL_COMP_ID_2,ATOM_SITE_LABEL_SEQ_ID_2 FROM DB2INST1.GEOM_CONTACT WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } DIST;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } DIST_ESD;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } SITE_SYMMETRY_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } SITE_SYMMETRY_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_ASYM_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } ATOM_SITE_AUTH_ATOM_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_COMP_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_SEQ_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_ASYM_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } ATOM_SITE_AUTH_ATOM_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_COMP_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_SEQ_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_ALT_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_ASYM_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } ATOM_SITE_LABEL_ATOM_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_COMP_ID_1;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } ATOM_SITE_LABEL_SEQ_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_ALT_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_ASYM_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } ATOM_SITE_LABEL_ATOM_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_COMP_ID_2;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } ATOM_SITE_LABEL_SEQ_ID_2;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_DOUBLE, &DIST.val, 0, &DIST.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_DOUBLE, &DIST_ESD.val, 0, &DIST_ESD.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &SITE_SYMMETRY_1.val, 10, &SITE_SYMMETRY_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_CHAR, &SITE_SYMMETRY_2.val, 10, &SITE_SYMMETRY_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 4");

    sqlrc = SQLBindCol( hstmt, 5, SQL_C_CHAR, &ATOM_SITE_ID_1.val, 10, &ATOM_SITE_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 5");

    sqlrc = SQLBindCol( hstmt, 6, SQL_C_CHAR, &ATOM_SITE_ID_2.val, 10, &ATOM_SITE_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 6");

    sqlrc = SQLBindCol( hstmt, 7, SQL_C_CHAR, &ATOM_SITE_AUTH_ASYM_ID_1.val, 10, &ATOM_SITE_AUTH_ASYM_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 7");

    sqlrc = SQLBindCol( hstmt, 8, SQL_C_CHAR, &ATOM_SITE_AUTH_ATOM_ID_1.val, 6, &ATOM_SITE_AUTH_ATOM_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 8");

    sqlrc = SQLBindCol( hstmt, 9, SQL_C_CHAR, &ATOM_SITE_AUTH_COMP_ID_1.val, 10, &ATOM_SITE_AUTH_COMP_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 9");

    sqlrc = SQLBindCol( hstmt, 10, SQL_C_CHAR, &ATOM_SITE_AUTH_SEQ_ID_1.val, 10, &ATOM_SITE_AUTH_SEQ_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 10");

    sqlrc = SQLBindCol( hstmt, 11, SQL_C_CHAR, &ATOM_SITE_AUTH_ASYM_ID_2.val, 10, &ATOM_SITE_AUTH_ASYM_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 11");

    sqlrc = SQLBindCol( hstmt, 12, SQL_C_CHAR, &ATOM_SITE_AUTH_ATOM_ID_2.val, 6, &ATOM_SITE_AUTH_ATOM_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 12");

    sqlrc = SQLBindCol( hstmt, 13, SQL_C_CHAR, &ATOM_SITE_AUTH_COMP_ID_2.val, 10, &ATOM_SITE_AUTH_COMP_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 13");

    sqlrc = SQLBindCol( hstmt, 14, SQL_C_CHAR, &ATOM_SITE_AUTH_SEQ_ID_2.val, 10, &ATOM_SITE_AUTH_SEQ_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 14");

    sqlrc = SQLBindCol( hstmt, 15, SQL_C_CHAR, &ATOM_SITE_LABEL_ALT_ID_1.val, 10, &ATOM_SITE_LABEL_ALT_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 15");

    sqlrc = SQLBindCol( hstmt, 16, SQL_C_CHAR, &ATOM_SITE_LABEL_ASYM_ID_1.val, 10, &ATOM_SITE_LABEL_ASYM_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 16");

    sqlrc = SQLBindCol( hstmt, 17, SQL_C_CHAR, &ATOM_SITE_LABEL_ATOM_ID_1.val, 6, &ATOM_SITE_LABEL_ATOM_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 17");

    sqlrc = SQLBindCol( hstmt, 18, SQL_C_CHAR, &ATOM_SITE_LABEL_COMP_ID_1.val, 10, &ATOM_SITE_LABEL_COMP_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 18");

    sqlrc = SQLBindCol( hstmt, 19, SQL_C_LONG, &ATOM_SITE_LABEL_SEQ_ID_1.val, 0, &ATOM_SITE_LABEL_SEQ_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 19");

    sqlrc = SQLBindCol( hstmt, 20, SQL_C_CHAR, &ATOM_SITE_LABEL_ALT_ID_2.val, 10, &ATOM_SITE_LABEL_ALT_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 20");

    sqlrc = SQLBindCol( hstmt, 21, SQL_C_CHAR, &ATOM_SITE_LABEL_ASYM_ID_2.val, 10, &ATOM_SITE_LABEL_ASYM_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 21");

    sqlrc = SQLBindCol( hstmt, 22, SQL_C_CHAR, &ATOM_SITE_LABEL_ATOM_ID_2.val, 6, &ATOM_SITE_LABEL_ATOM_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 22");

    sqlrc = SQLBindCol( hstmt, 23, SQL_C_CHAR, &ATOM_SITE_LABEL_COMP_ID_2.val, 10, &ATOM_SITE_LABEL_COMP_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 23");

    sqlrc = SQLBindCol( hstmt, 24, SQL_C_LONG, &ATOM_SITE_LABEL_SEQ_ID_2.val, 0, &ATOM_SITE_LABEL_SEQ_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLBindCol 24");

    listP = new MMS::GeomContactList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].dist = DIST.val;
        (*listP)[count].dist_esd = DIST_ESD.val;
        (*listP)[count].site_symmetry_1 = CORBA::string_dup((char*)SITE_SYMMETRY_1.val);
        (*listP)[count].site_symmetry_2 = CORBA::string_dup((char*)SITE_SYMMETRY_2.val);
        (*listP)[count].atom_site_id_1.id = CORBA::string_dup((char*)ATOM_SITE_ID_1.val);
        (*listP)[count].atom_site_id_1.index = atoi((char*)ATOM_SITE_ID_1.val);
        (*listP)[count].atom_site_id_2.id = CORBA::string_dup((char*)ATOM_SITE_ID_2.val);
        (*listP)[count].atom_site_id_2.index = atoi((char*)ATOM_SITE_ID_2.val);
        (*listP)[count].atom_site_auth_1.atom.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_ATOM_ID_1.val);
        (*listP)[count].atom_site_auth_1.atom.index = atoi((char*)ATOM_SITE_AUTH_ATOM_ID_1.val);
        (*listP)[count].atom_site_auth_1.asym.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_ASYM_ID_1.val);
        (*listP)[count].atom_site_auth_1.asym.index = atoi((char*)ATOM_SITE_AUTH_ASYM_ID_1.val);
        (*listP)[count].atom_site_auth_1.comp.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_COMP_ID_1.val);
        (*listP)[count].atom_site_auth_1.comp.index = atoi((char*)ATOM_SITE_AUTH_COMP_ID_1.val);
        (*listP)[count].atom_site_auth_1.seq.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_SEQ_ID_1.val);
        (*listP)[count].atom_site_auth_1.seq.index = atoi((char*)ATOM_SITE_AUTH_SEQ_ID_1.val);
        (*listP)[count].atom_site_auth_2.atom.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_ATOM_ID_2.val);
        (*listP)[count].atom_site_auth_2.atom.index = atoi((char*)ATOM_SITE_AUTH_ATOM_ID_2.val);
        (*listP)[count].atom_site_auth_2.asym.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_ASYM_ID_2.val);
        (*listP)[count].atom_site_auth_2.asym.index = atoi((char*)ATOM_SITE_AUTH_ASYM_ID_2.val);
        (*listP)[count].atom_site_auth_2.comp.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_COMP_ID_2.val);
        (*listP)[count].atom_site_auth_2.comp.index = atoi((char*)ATOM_SITE_AUTH_COMP_ID_2.val);
        (*listP)[count].atom_site_auth_2.seq.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_SEQ_ID_2.val);
        (*listP)[count].atom_site_auth_2.seq.index = atoi((char*)ATOM_SITE_AUTH_SEQ_ID_2.val);
        (*listP)[count].atom_site_label_1.atom.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ATOM_ID_1.val);
        (*listP)[count].atom_site_label_1.atom.index = atoi((char*)ATOM_SITE_LABEL_ATOM_ID_1.val);
        (*listP)[count].atom_site_label_1.alt.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ALT_ID_1.val);
        (*listP)[count].atom_site_label_1.alt.index = atoi((char*)ATOM_SITE_LABEL_ALT_ID_1.val);
        (*listP)[count].atom_site_label_1.asym.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ASYM_ID_1.val);
        (*listP)[count].atom_site_label_1.asym.index = atoi((char*)ATOM_SITE_LABEL_ASYM_ID_1.val);
        (*listP)[count].atom_site_label_1.comp.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_COMP_ID_1.val);
        (*listP)[count].atom_site_label_1.comp.index = atoi((char*)ATOM_SITE_LABEL_COMP_ID_1.val);
        (*listP)[count].atom_site_label_1.seq.id = itoa(ATOM_SITE_LABEL_SEQ_ID_1.val);
        (*listP)[count].atom_site_label_1.seq.index = ATOM_SITE_LABEL_SEQ_ID_1.val;
        (*listP)[count].atom_site_label_2.atom.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ATOM_ID_2.val);
        (*listP)[count].atom_site_label_2.atom.index = atoi((char*)ATOM_SITE_LABEL_ATOM_ID_2.val);
        (*listP)[count].atom_site_label_2.alt.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ALT_ID_2.val);
        (*listP)[count].atom_site_label_2.alt.index = atoi((char*)ATOM_SITE_LABEL_ALT_ID_2.val);
        (*listP)[count].atom_site_label_2.asym.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ASYM_ID_2.val);
        (*listP)[count].atom_site_label_2.asym.index = atoi((char*)ATOM_SITE_LABEL_ASYM_ID_2.val);
        (*listP)[count].atom_site_label_2.comp.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_COMP_ID_2.val);
        (*listP)[count].atom_site_label_2.comp.index = atoi((char*)ATOM_SITE_LABEL_COMP_ID_2.val);
        (*listP)[count].atom_site_label_2.seq.id = itoa(ATOM_SITE_LABEL_SEQ_ID_2.val);
        (*listP)[count].atom_site_label_2.seq.index = ATOM_SITE_LABEL_SEQ_ID_2.val;

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_contact_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::geom_hbond_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::GeomHbondList*
MMS_EntryImpl::get_geom_hbond_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::geom_torsion_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.GEOM_TORSION WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::geom_torsion_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_torsion_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_torsion_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_torsion_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_torsion_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_torsion_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_torsion_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_torsion_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::geom_torsion_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::GeomTorsionList*
MMS_EntryImpl::get_geom_torsion_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::GeomTorsionList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "GEOM_TORSION", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT SITE_SYMMETRY_1,SITE_SYMMETRY_2,SITE_SYMMETRY_3,SITE_SYMMETRY_4,VALUE,VALUE_ESD,ATOM_SITE_ID_1,ATOM_SITE_ID_2,ATOM_SITE_ID_3,ATOM_SITE_ID_4,ATOM_SITE_AUTH_ASYM_ID_1,ATOM_SITE_AUTH_ATOM_ID_1,ATOM_SITE_AUTH_COMP_ID_1,ATOM_SITE_AUTH_SEQ_ID_1,ATOM_SITE_AUTH_ASYM_ID_2,ATOM_SITE_AUTH_ATOM_ID_2,ATOM_SITE_AUTH_COMP_ID_2,ATOM_SITE_AUTH_SEQ_ID_2,ATOM_SITE_AUTH_ASYM_ID_3,ATOM_SITE_AUTH_ATOM_ID_3,ATOM_SITE_AUTH_COMP_ID_3,ATOM_SITE_AUTH_SEQ_ID_3,ATOM_SITE_AUTH_ASYM_ID_4,ATOM_SITE_AUTH_ATOM_ID_4,ATOM_SITE_AUTH_COMP_ID_4,ATOM_SITE_AUTH_SEQ_ID_4,ATOM_SITE_LABEL_ALT_ID_1,ATOM_SITE_LABEL_ASYM_ID_1,ATOM_SITE_LABEL_ATOM_ID_1,ATOM_SITE_LABEL_COMP_ID_1,ATOM_SITE_LABEL_SEQ_ID_1,ATOM_SITE_LABEL_ALT_ID_2,ATOM_SITE_LABEL_ASYM_ID_2,ATOM_SITE_LABEL_ATOM_ID_2,ATOM_SITE_LABEL_COMP_ID_2,ATOM_SITE_LABEL_SEQ_ID_2,ATOM_SITE_LABEL_ALT_ID_3,ATOM_SITE_LABEL_ASYM_ID_3,ATOM_SITE_LABEL_ATOM_ID_3,ATOM_SITE_LABEL_COMP_ID_3,ATOM_SITE_LABEL_SEQ_ID_3,ATOM_SITE_LABEL_ALT_ID_4,ATOM_SITE_LABEL_ASYM_ID_4,ATOM_SITE_LABEL_ATOM_ID_4,ATOM_SITE_LABEL_COMP_ID_4,ATOM_SITE_LABEL_SEQ_ID_4 FROM DB2INST1.GEOM_TORSION WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } SITE_SYMMETRY_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } SITE_SYMMETRY_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } SITE_SYMMETRY_3;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } SITE_SYMMETRY_4;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } VALUE;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } VALUE_ESD;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_ID_3;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_ID_4;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_ASYM_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } ATOM_SITE_AUTH_ATOM_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_COMP_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_SEQ_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_ASYM_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } ATOM_SITE_AUTH_ATOM_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_COMP_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_SEQ_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_ASYM_ID_3;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } ATOM_SITE_AUTH_ATOM_ID_3;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_COMP_ID_3;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_SEQ_ID_3;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_ASYM_ID_4;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } ATOM_SITE_AUTH_ATOM_ID_4;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_COMP_ID_4;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_AUTH_SEQ_ID_4;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_ALT_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_ASYM_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } ATOM_SITE_LABEL_ATOM_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_COMP_ID_1;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } ATOM_SITE_LABEL_SEQ_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_ALT_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_ASYM_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } ATOM_SITE_LABEL_ATOM_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_COMP_ID_2;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } ATOM_SITE_LABEL_SEQ_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_ALT_ID_3;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_ASYM_ID_3;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } ATOM_SITE_LABEL_ATOM_ID_3;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_COMP_ID_3;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } ATOM_SITE_LABEL_SEQ_ID_3;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_ALT_ID_4;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_ASYM_ID_4;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } ATOM_SITE_LABEL_ATOM_ID_4;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ATOM_SITE_LABEL_COMP_ID_4;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } ATOM_SITE_LABEL_SEQ_ID_4;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &SITE_SYMMETRY_1.val, 10, &SITE_SYMMETRY_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &SITE_SYMMETRY_2.val, 10, &SITE_SYMMETRY_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &SITE_SYMMETRY_3.val, 10, &SITE_SYMMETRY_3.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_CHAR, &SITE_SYMMETRY_4.val, 10, &SITE_SYMMETRY_4.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 4");

    sqlrc = SQLBindCol( hstmt, 5, SQL_C_DOUBLE, &VALUE.val, 0, &VALUE.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 5");

    sqlrc = SQLBindCol( hstmt, 6, SQL_C_DOUBLE, &VALUE_ESD.val, 0, &VALUE_ESD.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 6");

    sqlrc = SQLBindCol( hstmt, 7, SQL_C_CHAR, &ATOM_SITE_ID_1.val, 10, &ATOM_SITE_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 7");

    sqlrc = SQLBindCol( hstmt, 8, SQL_C_CHAR, &ATOM_SITE_ID_2.val, 10, &ATOM_SITE_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 8");

    sqlrc = SQLBindCol( hstmt, 9, SQL_C_CHAR, &ATOM_SITE_ID_3.val, 10, &ATOM_SITE_ID_3.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 9");

    sqlrc = SQLBindCol( hstmt, 10, SQL_C_CHAR, &ATOM_SITE_ID_4.val, 10, &ATOM_SITE_ID_4.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 10");

    sqlrc = SQLBindCol( hstmt, 11, SQL_C_CHAR, &ATOM_SITE_AUTH_ASYM_ID_1.val, 10, &ATOM_SITE_AUTH_ASYM_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 11");

    sqlrc = SQLBindCol( hstmt, 12, SQL_C_CHAR, &ATOM_SITE_AUTH_ATOM_ID_1.val, 6, &ATOM_SITE_AUTH_ATOM_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 12");

    sqlrc = SQLBindCol( hstmt, 13, SQL_C_CHAR, &ATOM_SITE_AUTH_COMP_ID_1.val, 10, &ATOM_SITE_AUTH_COMP_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 13");

    sqlrc = SQLBindCol( hstmt, 14, SQL_C_CHAR, &ATOM_SITE_AUTH_SEQ_ID_1.val, 10, &ATOM_SITE_AUTH_SEQ_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 14");

    sqlrc = SQLBindCol( hstmt, 15, SQL_C_CHAR, &ATOM_SITE_AUTH_ASYM_ID_2.val, 10, &ATOM_SITE_AUTH_ASYM_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 15");

    sqlrc = SQLBindCol( hstmt, 16, SQL_C_CHAR, &ATOM_SITE_AUTH_ATOM_ID_2.val, 6, &ATOM_SITE_AUTH_ATOM_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 16");

    sqlrc = SQLBindCol( hstmt, 17, SQL_C_CHAR, &ATOM_SITE_AUTH_COMP_ID_2.val, 10, &ATOM_SITE_AUTH_COMP_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 17");

    sqlrc = SQLBindCol( hstmt, 18, SQL_C_CHAR, &ATOM_SITE_AUTH_SEQ_ID_2.val, 10, &ATOM_SITE_AUTH_SEQ_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 18");

    sqlrc = SQLBindCol( hstmt, 19, SQL_C_CHAR, &ATOM_SITE_AUTH_ASYM_ID_3.val, 10, &ATOM_SITE_AUTH_ASYM_ID_3.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 19");

    sqlrc = SQLBindCol( hstmt, 20, SQL_C_CHAR, &ATOM_SITE_AUTH_ATOM_ID_3.val, 6, &ATOM_SITE_AUTH_ATOM_ID_3.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 20");

    sqlrc = SQLBindCol( hstmt, 21, SQL_C_CHAR, &ATOM_SITE_AUTH_COMP_ID_3.val, 10, &ATOM_SITE_AUTH_COMP_ID_3.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 21");

    sqlrc = SQLBindCol( hstmt, 22, SQL_C_CHAR, &ATOM_SITE_AUTH_SEQ_ID_3.val, 10, &ATOM_SITE_AUTH_SEQ_ID_3.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 22");

    sqlrc = SQLBindCol( hstmt, 23, SQL_C_CHAR, &ATOM_SITE_AUTH_ASYM_ID_4.val, 10, &ATOM_SITE_AUTH_ASYM_ID_4.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 23");

    sqlrc = SQLBindCol( hstmt, 24, SQL_C_CHAR, &ATOM_SITE_AUTH_ATOM_ID_4.val, 6, &ATOM_SITE_AUTH_ATOM_ID_4.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 24");

    sqlrc = SQLBindCol( hstmt, 25, SQL_C_CHAR, &ATOM_SITE_AUTH_COMP_ID_4.val, 10, &ATOM_SITE_AUTH_COMP_ID_4.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 25");

    sqlrc = SQLBindCol( hstmt, 26, SQL_C_CHAR, &ATOM_SITE_AUTH_SEQ_ID_4.val, 10, &ATOM_SITE_AUTH_SEQ_ID_4.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 26");

    sqlrc = SQLBindCol( hstmt, 27, SQL_C_CHAR, &ATOM_SITE_LABEL_ALT_ID_1.val, 10, &ATOM_SITE_LABEL_ALT_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 27");

    sqlrc = SQLBindCol( hstmt, 28, SQL_C_CHAR, &ATOM_SITE_LABEL_ASYM_ID_1.val, 10, &ATOM_SITE_LABEL_ASYM_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 28");

    sqlrc = SQLBindCol( hstmt, 29, SQL_C_CHAR, &ATOM_SITE_LABEL_ATOM_ID_1.val, 6, &ATOM_SITE_LABEL_ATOM_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 29");

    sqlrc = SQLBindCol( hstmt, 30, SQL_C_CHAR, &ATOM_SITE_LABEL_COMP_ID_1.val, 10, &ATOM_SITE_LABEL_COMP_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 30");

    sqlrc = SQLBindCol( hstmt, 31, SQL_C_LONG, &ATOM_SITE_LABEL_SEQ_ID_1.val, 0, &ATOM_SITE_LABEL_SEQ_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 31");

    sqlrc = SQLBindCol( hstmt, 32, SQL_C_CHAR, &ATOM_SITE_LABEL_ALT_ID_2.val, 10, &ATOM_SITE_LABEL_ALT_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 32");

    sqlrc = SQLBindCol( hstmt, 33, SQL_C_CHAR, &ATOM_SITE_LABEL_ASYM_ID_2.val, 10, &ATOM_SITE_LABEL_ASYM_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 33");

    sqlrc = SQLBindCol( hstmt, 34, SQL_C_CHAR, &ATOM_SITE_LABEL_ATOM_ID_2.val, 6, &ATOM_SITE_LABEL_ATOM_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 34");

    sqlrc = SQLBindCol( hstmt, 35, SQL_C_CHAR, &ATOM_SITE_LABEL_COMP_ID_2.val, 10, &ATOM_SITE_LABEL_COMP_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 35");

    sqlrc = SQLBindCol( hstmt, 36, SQL_C_LONG, &ATOM_SITE_LABEL_SEQ_ID_2.val, 0, &ATOM_SITE_LABEL_SEQ_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 36");

    sqlrc = SQLBindCol( hstmt, 37, SQL_C_CHAR, &ATOM_SITE_LABEL_ALT_ID_3.val, 10, &ATOM_SITE_LABEL_ALT_ID_3.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 37");

    sqlrc = SQLBindCol( hstmt, 38, SQL_C_CHAR, &ATOM_SITE_LABEL_ASYM_ID_3.val, 10, &ATOM_SITE_LABEL_ASYM_ID_3.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 38");

    sqlrc = SQLBindCol( hstmt, 39, SQL_C_CHAR, &ATOM_SITE_LABEL_ATOM_ID_3.val, 6, &ATOM_SITE_LABEL_ATOM_ID_3.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 39");

    sqlrc = SQLBindCol( hstmt, 40, SQL_C_CHAR, &ATOM_SITE_LABEL_COMP_ID_3.val, 10, &ATOM_SITE_LABEL_COMP_ID_3.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 40");

    sqlrc = SQLBindCol( hstmt, 41, SQL_C_LONG, &ATOM_SITE_LABEL_SEQ_ID_3.val, 0, &ATOM_SITE_LABEL_SEQ_ID_3.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 41");

    sqlrc = SQLBindCol( hstmt, 42, SQL_C_CHAR, &ATOM_SITE_LABEL_ALT_ID_4.val, 10, &ATOM_SITE_LABEL_ALT_ID_4.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 42");

    sqlrc = SQLBindCol( hstmt, 43, SQL_C_CHAR, &ATOM_SITE_LABEL_ASYM_ID_4.val, 10, &ATOM_SITE_LABEL_ASYM_ID_4.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 43");

    sqlrc = SQLBindCol( hstmt, 44, SQL_C_CHAR, &ATOM_SITE_LABEL_ATOM_ID_4.val, 6, &ATOM_SITE_LABEL_ATOM_ID_4.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 44");

    sqlrc = SQLBindCol( hstmt, 45, SQL_C_CHAR, &ATOM_SITE_LABEL_COMP_ID_4.val, 10, &ATOM_SITE_LABEL_COMP_ID_4.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 45");

    sqlrc = SQLBindCol( hstmt, 46, SQL_C_LONG, &ATOM_SITE_LABEL_SEQ_ID_4.val, 0, &ATOM_SITE_LABEL_SEQ_ID_4.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLBindCol 46");

    listP = new MMS::GeomTorsionList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].site_symmetry_1 = CORBA::string_dup((char*)SITE_SYMMETRY_1.val);
        (*listP)[count].site_symmetry_2 = CORBA::string_dup((char*)SITE_SYMMETRY_2.val);
        (*listP)[count].site_symmetry_3 = CORBA::string_dup((char*)SITE_SYMMETRY_3.val);
        (*listP)[count].site_symmetry_4 = CORBA::string_dup((char*)SITE_SYMMETRY_4.val);
        (*listP)[count].value = VALUE.val;
        (*listP)[count].value_esd = VALUE_ESD.val;
        (*listP)[count].atom_site_id_1.id = CORBA::string_dup((char*)ATOM_SITE_ID_1.val);
        (*listP)[count].atom_site_id_1.index = atoi((char*)ATOM_SITE_ID_1.val);
        (*listP)[count].atom_site_id_2.id = CORBA::string_dup((char*)ATOM_SITE_ID_2.val);
        (*listP)[count].atom_site_id_2.index = atoi((char*)ATOM_SITE_ID_2.val);
        (*listP)[count].atom_site_id_3.id = CORBA::string_dup((char*)ATOM_SITE_ID_3.val);
        (*listP)[count].atom_site_id_3.index = atoi((char*)ATOM_SITE_ID_3.val);
        (*listP)[count].atom_site_id_4.id = CORBA::string_dup((char*)ATOM_SITE_ID_4.val);
        (*listP)[count].atom_site_id_4.index = atoi((char*)ATOM_SITE_ID_4.val);
        (*listP)[count].atom_site_auth_1.atom.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_ATOM_ID_1.val);
        (*listP)[count].atom_site_auth_1.atom.index = atoi((char*)ATOM_SITE_AUTH_ATOM_ID_1.val);
        (*listP)[count].atom_site_auth_1.asym.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_ASYM_ID_1.val);
        (*listP)[count].atom_site_auth_1.asym.index = atoi((char*)ATOM_SITE_AUTH_ASYM_ID_1.val);
        (*listP)[count].atom_site_auth_1.comp.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_COMP_ID_1.val);
        (*listP)[count].atom_site_auth_1.comp.index = atoi((char*)ATOM_SITE_AUTH_COMP_ID_1.val);
        (*listP)[count].atom_site_auth_1.seq.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_SEQ_ID_1.val);
        (*listP)[count].atom_site_auth_1.seq.index = atoi((char*)ATOM_SITE_AUTH_SEQ_ID_1.val);
        (*listP)[count].atom_site_auth_2.atom.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_ATOM_ID_2.val);
        (*listP)[count].atom_site_auth_2.atom.index = atoi((char*)ATOM_SITE_AUTH_ATOM_ID_2.val);
        (*listP)[count].atom_site_auth_2.asym.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_ASYM_ID_2.val);
        (*listP)[count].atom_site_auth_2.asym.index = atoi((char*)ATOM_SITE_AUTH_ASYM_ID_2.val);
        (*listP)[count].atom_site_auth_2.comp.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_COMP_ID_2.val);
        (*listP)[count].atom_site_auth_2.comp.index = atoi((char*)ATOM_SITE_AUTH_COMP_ID_2.val);
        (*listP)[count].atom_site_auth_2.seq.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_SEQ_ID_2.val);
        (*listP)[count].atom_site_auth_2.seq.index = atoi((char*)ATOM_SITE_AUTH_SEQ_ID_2.val);
        (*listP)[count].atom_site_auth_3.atom.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_ATOM_ID_3.val);
        (*listP)[count].atom_site_auth_3.atom.index = atoi((char*)ATOM_SITE_AUTH_ATOM_ID_3.val);
        (*listP)[count].atom_site_auth_3.asym.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_ASYM_ID_3.val);
        (*listP)[count].atom_site_auth_3.asym.index = atoi((char*)ATOM_SITE_AUTH_ASYM_ID_3.val);
        (*listP)[count].atom_site_auth_3.comp.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_COMP_ID_3.val);
        (*listP)[count].atom_site_auth_3.comp.index = atoi((char*)ATOM_SITE_AUTH_COMP_ID_3.val);
        (*listP)[count].atom_site_auth_3.seq.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_SEQ_ID_3.val);
        (*listP)[count].atom_site_auth_3.seq.index = atoi((char*)ATOM_SITE_AUTH_SEQ_ID_3.val);
        (*listP)[count].atom_site_auth_4.atom.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_ATOM_ID_4.val);
        (*listP)[count].atom_site_auth_4.atom.index = atoi((char*)ATOM_SITE_AUTH_ATOM_ID_4.val);
        (*listP)[count].atom_site_auth_4.asym.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_ASYM_ID_4.val);
        (*listP)[count].atom_site_auth_4.asym.index = atoi((char*)ATOM_SITE_AUTH_ASYM_ID_4.val);
        (*listP)[count].atom_site_auth_4.comp.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_COMP_ID_4.val);
        (*listP)[count].atom_site_auth_4.comp.index = atoi((char*)ATOM_SITE_AUTH_COMP_ID_4.val);
        (*listP)[count].atom_site_auth_4.seq.id = CORBA::string_dup((char*)ATOM_SITE_AUTH_SEQ_ID_4.val);
        (*listP)[count].atom_site_auth_4.seq.index = atoi((char*)ATOM_SITE_AUTH_SEQ_ID_4.val);
        (*listP)[count].atom_site_label_1.atom.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ATOM_ID_1.val);
        (*listP)[count].atom_site_label_1.atom.index = atoi((char*)ATOM_SITE_LABEL_ATOM_ID_1.val);
        (*listP)[count].atom_site_label_1.alt.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ALT_ID_1.val);
        (*listP)[count].atom_site_label_1.alt.index = atoi((char*)ATOM_SITE_LABEL_ALT_ID_1.val);
        (*listP)[count].atom_site_label_1.asym.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ASYM_ID_1.val);
        (*listP)[count].atom_site_label_1.asym.index = atoi((char*)ATOM_SITE_LABEL_ASYM_ID_1.val);
        (*listP)[count].atom_site_label_1.comp.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_COMP_ID_1.val);
        (*listP)[count].atom_site_label_1.comp.index = atoi((char*)ATOM_SITE_LABEL_COMP_ID_1.val);
        (*listP)[count].atom_site_label_1.seq.id = itoa(ATOM_SITE_LABEL_SEQ_ID_1.val);
        (*listP)[count].atom_site_label_1.seq.index = ATOM_SITE_LABEL_SEQ_ID_1.val;
        (*listP)[count].atom_site_label_2.atom.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ATOM_ID_2.val);
        (*listP)[count].atom_site_label_2.atom.index = atoi((char*)ATOM_SITE_LABEL_ATOM_ID_2.val);
        (*listP)[count].atom_site_label_2.alt.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ALT_ID_2.val);
        (*listP)[count].atom_site_label_2.alt.index = atoi((char*)ATOM_SITE_LABEL_ALT_ID_2.val);
        (*listP)[count].atom_site_label_2.asym.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ASYM_ID_2.val);
        (*listP)[count].atom_site_label_2.asym.index = atoi((char*)ATOM_SITE_LABEL_ASYM_ID_2.val);
        (*listP)[count].atom_site_label_2.comp.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_COMP_ID_2.val);
        (*listP)[count].atom_site_label_2.comp.index = atoi((char*)ATOM_SITE_LABEL_COMP_ID_2.val);
        (*listP)[count].atom_site_label_2.seq.id = itoa(ATOM_SITE_LABEL_SEQ_ID_2.val);
        (*listP)[count].atom_site_label_2.seq.index = ATOM_SITE_LABEL_SEQ_ID_2.val;
        (*listP)[count].atom_site_label_3.atom.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ATOM_ID_3.val);
        (*listP)[count].atom_site_label_3.atom.index = atoi((char*)ATOM_SITE_LABEL_ATOM_ID_3.val);
        (*listP)[count].atom_site_label_3.alt.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ALT_ID_3.val);
        (*listP)[count].atom_site_label_3.alt.index = atoi((char*)ATOM_SITE_LABEL_ALT_ID_3.val);
        (*listP)[count].atom_site_label_3.asym.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ASYM_ID_3.val);
        (*listP)[count].atom_site_label_3.asym.index = atoi((char*)ATOM_SITE_LABEL_ASYM_ID_3.val);
        (*listP)[count].atom_site_label_3.comp.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_COMP_ID_3.val);
        (*listP)[count].atom_site_label_3.comp.index = atoi((char*)ATOM_SITE_LABEL_COMP_ID_3.val);
        (*listP)[count].atom_site_label_3.seq.id = itoa(ATOM_SITE_LABEL_SEQ_ID_3.val);
        (*listP)[count].atom_site_label_3.seq.index = ATOM_SITE_LABEL_SEQ_ID_3.val;
        (*listP)[count].atom_site_label_4.atom.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ATOM_ID_4.val);
        (*listP)[count].atom_site_label_4.atom.index = atoi((char*)ATOM_SITE_LABEL_ATOM_ID_4.val);
        (*listP)[count].atom_site_label_4.alt.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ALT_ID_4.val);
        (*listP)[count].atom_site_label_4.alt.index = atoi((char*)ATOM_SITE_LABEL_ALT_ID_4.val);
        (*listP)[count].atom_site_label_4.asym.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_ASYM_ID_4.val);
        (*listP)[count].atom_site_label_4.asym.index = atoi((char*)ATOM_SITE_LABEL_ASYM_ID_4.val);
        (*listP)[count].atom_site_label_4.comp.id = CORBA::string_dup((char*)ATOM_SITE_LABEL_COMP_ID_4.val);
        (*listP)[count].atom_site_label_4.comp.index = atoi((char*)ATOM_SITE_LABEL_COMP_ID_4.val);
        (*listP)[count].atom_site_label_4.seq.id = itoa(ATOM_SITE_LABEL_SEQ_ID_4.val);
        (*listP)[count].atom_site_label_4.seq.index = ATOM_SITE_LABEL_SEQ_ID_4.val;

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_geom_torsion_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::struct_asym_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.STRUCT_ASYM WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::struct_asym_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_asym_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_asym_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_asym_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_asym_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_asym_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_asym_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_asym_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_asym_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::StructAsymList*
MMS_EntryImpl::get_struct_asym_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::StructAsymList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_asym_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "STRUCT_ASYM", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT DETAILS,ID,ENTITY_ID FROM DB2INST1.STRUCT_ASYM WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_asym_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_asym_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_asym_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_asym_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } DETAILS;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ENTITY_ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &DETAILS.val, 200, &DETAILS.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_asym_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &ID.val, 10, &ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_asym_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &ENTITY_ID.val, 10, &ENTITY_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_asym_list()", "SQLBindCol 3");

    listP = new MMS::StructAsymList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_asym_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].details = CORBA::string_dup((char*)DETAILS.val);
        (*listP)[count].id = CORBA::string_dup((char*)ID.val);
        (*listP)[count].entity.id = CORBA::string_dup((char*)ENTITY_ID.val);
        (*listP)[count].entity.index = atoi((char*)ENTITY_ID.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_struct_asym_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_asym_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::struct_biol_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.STRUCT_BIOL WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::struct_biol_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_biol_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_biol_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_biol_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_biol_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_biol_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_biol_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_biol_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_biol_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::StructBiolList*
MMS_EntryImpl::get_struct_biol_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::StructBiolList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_biol_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "STRUCT_BIOL", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT DETAILS,ID FROM DB2INST1.STRUCT_BIOL WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_biol_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_biol_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_biol_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_biol_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[4000];
    } DETAILS;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[80];
    } ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &DETAILS.val, 4000, &DETAILS.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_biol_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &ID.val, 80, &ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_biol_list()", "SQLBindCol 2");

    listP = new MMS::StructBiolList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_biol_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].details = CORBA::string_dup((char*)DETAILS.val);
        (*listP)[count].id = CORBA::string_dup((char*)ID.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_struct_biol_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_biol_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::struct_biol_gen_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.STRUCT_BIOL_GEN WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::struct_biol_gen_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_biol_gen_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_biol_gen_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_biol_gen_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_biol_gen_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_biol_gen_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_biol_gen_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_biol_gen_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_biol_gen_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::StructBiolGenList*
MMS_EntryImpl::get_struct_biol_gen_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::StructBiolGenList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_biol_gen_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "STRUCT_BIOL_GEN", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT DETAILS,SYMMETRY,ASYM_ID,BIOL_ID FROM DB2INST1.STRUCT_BIOL_GEN WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_biol_gen_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_biol_gen_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_biol_gen_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_biol_gen_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } DETAILS;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } SYMMETRY;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ASYM_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[80];
    } BIOL_ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &DETAILS.val, 200, &DETAILS.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_biol_gen_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &SYMMETRY.val, 10, &SYMMETRY.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_biol_gen_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &ASYM_ID.val, 10, &ASYM_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_biol_gen_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_CHAR, &BIOL_ID.val, 80, &BIOL_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_biol_gen_list()", "SQLBindCol 4");

    listP = new MMS::StructBiolGenList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_biol_gen_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].details = CORBA::string_dup((char*)DETAILS.val);
        (*listP)[count].symmetry = CORBA::string_dup((char*)SYMMETRY.val);
        (*listP)[count].asym.id = CORBA::string_dup((char*)ASYM_ID.val);
        (*listP)[count].asym.index = atoi((char*)ASYM_ID.val);
        (*listP)[count].biol.id = CORBA::string_dup((char*)BIOL_ID.val);
        (*listP)[count].biol.index = atoi((char*)BIOL_ID.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_struct_biol_gen_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_biol_gen_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::struct_biol_keywords_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::StructBiolKeywordsList*
MMS_EntryImpl::get_struct_biol_keywords_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::struct_biol_view_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::StructBiolViewList*
MMS_EntryImpl::get_struct_biol_view_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::struct_conf_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.STRUCT_CONF WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conf_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conf_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conf_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conf_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conf_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conf_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conf_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conf_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conf_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::StructConfList*
MMS_EntryImpl::get_struct_conf_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::StructConfList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "STRUCT_CONF", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT DETAILS,ID,CONF_TYPE_ID,BEG_AUTH_ASYM_ID,BEG_AUTH_COMP_ID,BEG_AUTH_SEQ_ID,BEG_LABEL_ASYM_ID,BEG_LABEL_COMP_ID,BEG_LABEL_SEQ_ID,END_AUTH_ASYM_ID,END_AUTH_COMP_ID,END_AUTH_SEQ_ID,END_LABEL_ASYM_ID,END_LABEL_COMP_ID,END_LABEL_SEQ_ID FROM DB2INST1.STRUCT_CONF WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } DETAILS;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } CONF_TYPE_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } BEG_AUTH_ASYM_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } BEG_AUTH_COMP_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } BEG_AUTH_SEQ_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } BEG_LABEL_ASYM_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } BEG_LABEL_COMP_ID;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } BEG_LABEL_SEQ_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } END_AUTH_ASYM_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } END_AUTH_COMP_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } END_AUTH_SEQ_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } END_LABEL_ASYM_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } END_LABEL_COMP_ID;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } END_LABEL_SEQ_ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &DETAILS.val, 200, &DETAILS.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &ID.val, 10, &ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &CONF_TYPE_ID.val, 10, &CONF_TYPE_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_CHAR, &BEG_AUTH_ASYM_ID.val, 10, &BEG_AUTH_ASYM_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_list()", "SQLBindCol 4");

    sqlrc = SQLBindCol( hstmt, 5, SQL_C_CHAR, &BEG_AUTH_COMP_ID.val, 10, &BEG_AUTH_COMP_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_list()", "SQLBindCol 5");

    sqlrc = SQLBindCol( hstmt, 6, SQL_C_CHAR, &BEG_AUTH_SEQ_ID.val, 10, &BEG_AUTH_SEQ_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_list()", "SQLBindCol 6");

    sqlrc = SQLBindCol( hstmt, 7, SQL_C_CHAR, &BEG_LABEL_ASYM_ID.val, 10, &BEG_LABEL_ASYM_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_list()", "SQLBindCol 7");

    sqlrc = SQLBindCol( hstmt, 8, SQL_C_CHAR, &BEG_LABEL_COMP_ID.val, 10, &BEG_LABEL_COMP_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_list()", "SQLBindCol 8");

    sqlrc = SQLBindCol( hstmt, 9, SQL_C_LONG, &BEG_LABEL_SEQ_ID.val, 0, &BEG_LABEL_SEQ_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_list()", "SQLBindCol 9");

    sqlrc = SQLBindCol( hstmt, 10, SQL_C_CHAR, &END_AUTH_ASYM_ID.val, 10, &END_AUTH_ASYM_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_list()", "SQLBindCol 10");

    sqlrc = SQLBindCol( hstmt, 11, SQL_C_CHAR, &END_AUTH_COMP_ID.val, 10, &END_AUTH_COMP_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_list()", "SQLBindCol 11");

    sqlrc = SQLBindCol( hstmt, 12, SQL_C_CHAR, &END_AUTH_SEQ_ID.val, 10, &END_AUTH_SEQ_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_list()", "SQLBindCol 12");

    sqlrc = SQLBindCol( hstmt, 13, SQL_C_CHAR, &END_LABEL_ASYM_ID.val, 10, &END_LABEL_ASYM_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_list()", "SQLBindCol 13");

    sqlrc = SQLBindCol( hstmt, 14, SQL_C_CHAR, &END_LABEL_COMP_ID.val, 10, &END_LABEL_COMP_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_list()", "SQLBindCol 14");

    sqlrc = SQLBindCol( hstmt, 15, SQL_C_LONG, &END_LABEL_SEQ_ID.val, 0, &END_LABEL_SEQ_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_list()", "SQLBindCol 15");

    listP = new MMS::StructConfList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].details = CORBA::string_dup((char*)DETAILS.val);
        (*listP)[count].id = CORBA::string_dup((char*)ID.val);
        (*listP)[count].conf_type.id = CORBA::string_dup((char*)CONF_TYPE_ID.val);
        (*listP)[count].conf_type.index = atoi((char*)CONF_TYPE_ID.val);
        (*listP)[count].beg_auth.seq.id = CORBA::string_dup((char*)BEG_AUTH_SEQ_ID.val);
        (*listP)[count].beg_auth.seq.index = atoi((char*)BEG_AUTH_SEQ_ID.val);
        (*listP)[count].beg_auth.asym.id = CORBA::string_dup((char*)BEG_AUTH_ASYM_ID.val);
        (*listP)[count].beg_auth.asym.index = atoi((char*)BEG_AUTH_ASYM_ID.val);
        (*listP)[count].beg_auth.comp.id = CORBA::string_dup((char*)BEG_AUTH_COMP_ID.val);
        (*listP)[count].beg_auth.comp.index = atoi((char*)BEG_AUTH_COMP_ID.val);
        (*listP)[count].beg_label.seq.id = itoa(BEG_LABEL_SEQ_ID.val);
        (*listP)[count].beg_label.seq.index = BEG_LABEL_SEQ_ID.val;
        (*listP)[count].beg_label.asym.id = CORBA::string_dup((char*)BEG_LABEL_ASYM_ID.val);
        (*listP)[count].beg_label.asym.index = atoi((char*)BEG_LABEL_ASYM_ID.val);
        (*listP)[count].beg_label.comp.id = CORBA::string_dup((char*)BEG_LABEL_COMP_ID.val);
        (*listP)[count].beg_label.comp.index = atoi((char*)BEG_LABEL_COMP_ID.val);
        (*listP)[count].end_auth.seq.id = CORBA::string_dup((char*)END_AUTH_SEQ_ID.val);
        (*listP)[count].end_auth.seq.index = atoi((char*)END_AUTH_SEQ_ID.val);
        (*listP)[count].end_auth.asym.id = CORBA::string_dup((char*)END_AUTH_ASYM_ID.val);
        (*listP)[count].end_auth.asym.index = atoi((char*)END_AUTH_ASYM_ID.val);
        (*listP)[count].end_auth.comp.id = CORBA::string_dup((char*)END_AUTH_COMP_ID.val);
        (*listP)[count].end_auth.comp.index = atoi((char*)END_AUTH_COMP_ID.val);
        (*listP)[count].end_label.seq.id = itoa(END_LABEL_SEQ_ID.val);
        (*listP)[count].end_label.seq.index = END_LABEL_SEQ_ID.val;
        (*listP)[count].end_label.asym.id = CORBA::string_dup((char*)END_LABEL_ASYM_ID.val);
        (*listP)[count].end_label.asym.index = atoi((char*)END_LABEL_ASYM_ID.val);
        (*listP)[count].end_label.comp.id = CORBA::string_dup((char*)END_LABEL_COMP_ID.val);
        (*listP)[count].end_label.comp.index = atoi((char*)END_LABEL_COMP_ID.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::struct_conf_type_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.STRUCT_CONF_TYPE WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conf_type_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conf_type_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conf_type_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conf_type_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conf_type_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conf_type_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conf_type_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conf_type_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conf_type_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::StructConfTypeList*
MMS_EntryImpl::get_struct_conf_type_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::StructConfTypeList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_type_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "STRUCT_CONF_TYPE", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT CRITERIA,ID,REFERENCE FROM DB2INST1.STRUCT_CONF_TYPE WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_type_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_type_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_type_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_type_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } CRITERIA;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } REFERENCE;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &CRITERIA.val, 200, &CRITERIA.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_type_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &ID.val, 10, &ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_type_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &REFERENCE.val, 200, &REFERENCE.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_type_list()", "SQLBindCol 3");

    listP = new MMS::StructConfTypeList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_type_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].criteria = CORBA::string_dup((char*)CRITERIA.val);
        (*listP)[count].id = CORBA::string_dup((char*)ID.val);
        (*listP)[count].reference = CORBA::string_dup((char*)REFERENCE.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_type_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conf_type_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::struct_conn_type_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.STRUCT_CONN_TYPE WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conn_type_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conn_type_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conn_type_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conn_type_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conn_type_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conn_type_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conn_type_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conn_type_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_conn_type_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::StructConnTypeList*
MMS_EntryImpl::get_struct_conn_type_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::StructConnTypeList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conn_type_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "STRUCT_CONN_TYPE", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT CRITERIA,ID,REFERENCE FROM DB2INST1.STRUCT_CONN_TYPE WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conn_type_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conn_type_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conn_type_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conn_type_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } CRITERIA;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[80];
    } ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } REFERENCE;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &CRITERIA.val, 200, &CRITERIA.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conn_type_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &ID.val, 80, &ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conn_type_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &REFERENCE.val, 200, &REFERENCE.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conn_type_list()", "SQLBindCol 3");

    listP = new MMS::StructConnTypeList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conn_type_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].criteria = CORBA::string_dup((char*)CRITERIA.val);
        (*listP)[count].id = CORBA::string_dup((char*)ID.val);
        (*listP)[count].reference = CORBA::string_dup((char*)REFERENCE.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conn_type_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_conn_type_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::struct_keywords_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.STRUCT_KEYWORDS WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::struct_keywords_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_keywords_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_keywords_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_keywords_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_keywords_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_keywords_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_keywords_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_keywords_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_keywords_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::StructKeywordsList*
MMS_EntryImpl::get_struct_keywords_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::StructKeywordsList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_keywords_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "STRUCT_KEYWORDS", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT TEXT,ENTRY_ID FROM DB2INST1.STRUCT_KEYWORDS WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_keywords_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_keywords_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_keywords_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_keywords_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[400];
    } TEXT;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ENTRY_ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &TEXT.val, 400, &TEXT.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_keywords_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &ENTRY_ID.val, 10, &ENTRY_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_keywords_list()", "SQLBindCol 2");

    listP = new MMS::StructKeywordsList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_keywords_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].text = CORBA::string_dup((char*)TEXT.val);
        (*listP)[count].entry.id = CORBA::string_dup((char*)ENTRY_ID.val);
        (*listP)[count].entry.index = atoi((char*)ENTRY_ID.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_struct_keywords_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_keywords_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::struct_mon_details_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::StructMonDetailsList*
MMS_EntryImpl::get_struct_mon_details_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::struct_mon_nucl_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::StructMonNuclList*
MMS_EntryImpl::get_struct_mon_nucl_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::struct_mon_prot_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::StructMonProtList*
MMS_EntryImpl::get_struct_mon_prot_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::struct_mon_prot_cis_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.STRUCT_MON_PROT_CIS WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::struct_mon_prot_cis_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_mon_prot_cis_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_mon_prot_cis_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_mon_prot_cis_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_mon_prot_cis_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_mon_prot_cis_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_mon_prot_cis_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_mon_prot_cis_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_mon_prot_cis_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::StructMonProtCisList*
MMS_EntryImpl::get_struct_mon_prot_cis_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::StructMonProtCisList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_mon_prot_cis_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "STRUCT_MON_PROT_CIS", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT AUTH_ASYM_ID,AUTH_COMP_ID,AUTH_SEQ_ID,LABEL_ALT_ID,LABEL_ASYM_ID,LABEL_COMP_ID,LABEL_SEQ_ID FROM DB2INST1.STRUCT_MON_PROT_CIS WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_mon_prot_cis_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_mon_prot_cis_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_mon_prot_cis_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_mon_prot_cis_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } AUTH_ASYM_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } AUTH_COMP_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } AUTH_SEQ_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } LABEL_ALT_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } LABEL_ASYM_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } LABEL_COMP_ID;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } LABEL_SEQ_ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &AUTH_ASYM_ID.val, 10, &AUTH_ASYM_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_mon_prot_cis_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &AUTH_COMP_ID.val, 10, &AUTH_COMP_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_mon_prot_cis_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &AUTH_SEQ_ID.val, 10, &AUTH_SEQ_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_mon_prot_cis_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_CHAR, &LABEL_ALT_ID.val, 10, &LABEL_ALT_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_mon_prot_cis_list()", "SQLBindCol 4");

    sqlrc = SQLBindCol( hstmt, 5, SQL_C_CHAR, &LABEL_ASYM_ID.val, 10, &LABEL_ASYM_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_mon_prot_cis_list()", "SQLBindCol 5");

    sqlrc = SQLBindCol( hstmt, 6, SQL_C_CHAR, &LABEL_COMP_ID.val, 10, &LABEL_COMP_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_mon_prot_cis_list()", "SQLBindCol 6");

    sqlrc = SQLBindCol( hstmt, 7, SQL_C_LONG, &LABEL_SEQ_ID.val, 0, &LABEL_SEQ_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_mon_prot_cis_list()", "SQLBindCol 7");

    listP = new MMS::StructMonProtCisList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_mon_prot_cis_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].auth.seq.id = CORBA::string_dup((char*)AUTH_SEQ_ID.val);
        (*listP)[count].auth.seq.index = atoi((char*)AUTH_SEQ_ID.val);
        (*listP)[count].auth.asym.id = CORBA::string_dup((char*)AUTH_ASYM_ID.val);
        (*listP)[count].auth.asym.index = atoi((char*)AUTH_ASYM_ID.val);
        (*listP)[count].auth.comp.id = CORBA::string_dup((char*)AUTH_COMP_ID.val);
        (*listP)[count].auth.comp.index = atoi((char*)AUTH_COMP_ID.val);
        (*listP)[count].label.seq.id = itoa(LABEL_SEQ_ID.val);
        (*listP)[count].label.seq.index = LABEL_SEQ_ID.val;
        (*listP)[count].label.alt.id = CORBA::string_dup((char*)LABEL_ALT_ID.val);
        (*listP)[count].label.alt.index = atoi((char*)LABEL_ALT_ID.val);
        (*listP)[count].label.asym.id = CORBA::string_dup((char*)LABEL_ASYM_ID.val);
        (*listP)[count].label.asym.index = atoi((char*)LABEL_ASYM_ID.val);
        (*listP)[count].label.comp.id = CORBA::string_dup((char*)LABEL_COMP_ID.val);
        (*listP)[count].label.comp.index = atoi((char*)LABEL_COMP_ID.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_struct_mon_prot_cis_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_mon_prot_cis_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::struct_ncs_dom_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.STRUCT_NCS_DOM WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_dom_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_dom_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_dom_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_dom_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_dom_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_dom_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_dom_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_dom_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_dom_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::StructNcsDomList*
MMS_EntryImpl::get_struct_ncs_dom_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::StructNcsDomList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "STRUCT_NCS_DOM", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT DETAILS,ID FROM DB2INST1.STRUCT_NCS_DOM WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } DETAILS;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &DETAILS.val, 200, &DETAILS.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &ID.val, 10, &ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_list()", "SQLBindCol 2");

    listP = new MMS::StructNcsDomList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].details = CORBA::string_dup((char*)DETAILS.val);
        (*listP)[count].id = CORBA::string_dup((char*)ID.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::struct_ncs_dom_lim_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.STRUCT_NCS_DOM_LIM WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_dom_lim_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_dom_lim_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_dom_lim_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_dom_lim_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_dom_lim_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_dom_lim_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_dom_lim_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_dom_lim_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_dom_lim_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::StructNcsDomLimList*
MMS_EntryImpl::get_struct_ncs_dom_lim_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::StructNcsDomLimList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_lim_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "STRUCT_NCS_DOM_LIM", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT DOM_ID,BEG_AUTH_ASYM_ID,BEG_AUTH_COMP_ID,BEG_AUTH_SEQ_ID,BEG_LABEL_ALT_ID,BEG_LABEL_ASYM_ID,BEG_LABEL_COMP_ID,BEG_LABEL_SEQ_ID,END_AUTH_ASYM_ID,END_AUTH_COMP_ID,END_AUTH_SEQ_ID,END_LABEL_ALT_ID,END_LABEL_ASYM_ID,END_LABEL_COMP_ID,END_LABEL_SEQ_ID FROM DB2INST1.STRUCT_NCS_DOM_LIM WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_lim_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_lim_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_lim_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_lim_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } DOM_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } BEG_AUTH_ASYM_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } BEG_AUTH_COMP_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } BEG_AUTH_SEQ_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } BEG_LABEL_ALT_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } BEG_LABEL_ASYM_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } BEG_LABEL_COMP_ID;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } BEG_LABEL_SEQ_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } END_AUTH_ASYM_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } END_AUTH_COMP_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } END_AUTH_SEQ_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } END_LABEL_ALT_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } END_LABEL_ASYM_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } END_LABEL_COMP_ID;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } END_LABEL_SEQ_ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &DOM_ID.val, 10, &DOM_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_lim_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &BEG_AUTH_ASYM_ID.val, 10, &BEG_AUTH_ASYM_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_lim_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &BEG_AUTH_COMP_ID.val, 10, &BEG_AUTH_COMP_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_lim_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_CHAR, &BEG_AUTH_SEQ_ID.val, 10, &BEG_AUTH_SEQ_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_lim_list()", "SQLBindCol 4");

    sqlrc = SQLBindCol( hstmt, 5, SQL_C_CHAR, &BEG_LABEL_ALT_ID.val, 10, &BEG_LABEL_ALT_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_lim_list()", "SQLBindCol 5");

    sqlrc = SQLBindCol( hstmt, 6, SQL_C_CHAR, &BEG_LABEL_ASYM_ID.val, 10, &BEG_LABEL_ASYM_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_lim_list()", "SQLBindCol 6");

    sqlrc = SQLBindCol( hstmt, 7, SQL_C_CHAR, &BEG_LABEL_COMP_ID.val, 10, &BEG_LABEL_COMP_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_lim_list()", "SQLBindCol 7");

    sqlrc = SQLBindCol( hstmt, 8, SQL_C_LONG, &BEG_LABEL_SEQ_ID.val, 0, &BEG_LABEL_SEQ_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_lim_list()", "SQLBindCol 8");

    sqlrc = SQLBindCol( hstmt, 9, SQL_C_CHAR, &END_AUTH_ASYM_ID.val, 10, &END_AUTH_ASYM_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_lim_list()", "SQLBindCol 9");

    sqlrc = SQLBindCol( hstmt, 10, SQL_C_CHAR, &END_AUTH_COMP_ID.val, 10, &END_AUTH_COMP_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_lim_list()", "SQLBindCol 10");

    sqlrc = SQLBindCol( hstmt, 11, SQL_C_CHAR, &END_AUTH_SEQ_ID.val, 10, &END_AUTH_SEQ_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_lim_list()", "SQLBindCol 11");

    sqlrc = SQLBindCol( hstmt, 12, SQL_C_CHAR, &END_LABEL_ALT_ID.val, 10, &END_LABEL_ALT_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_lim_list()", "SQLBindCol 12");

    sqlrc = SQLBindCol( hstmt, 13, SQL_C_CHAR, &END_LABEL_ASYM_ID.val, 10, &END_LABEL_ASYM_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_lim_list()", "SQLBindCol 13");

    sqlrc = SQLBindCol( hstmt, 14, SQL_C_CHAR, &END_LABEL_COMP_ID.val, 10, &END_LABEL_COMP_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_lim_list()", "SQLBindCol 14");

    sqlrc = SQLBindCol( hstmt, 15, SQL_C_LONG, &END_LABEL_SEQ_ID.val, 0, &END_LABEL_SEQ_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_lim_list()", "SQLBindCol 15");

    listP = new MMS::StructNcsDomLimList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_lim_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].dom.id = CORBA::string_dup((char*)DOM_ID.val);
        (*listP)[count].dom.index = atoi((char*)DOM_ID.val);
        (*listP)[count].beg_auth.seq.id = CORBA::string_dup((char*)BEG_AUTH_SEQ_ID.val);
        (*listP)[count].beg_auth.seq.index = atoi((char*)BEG_AUTH_SEQ_ID.val);
        (*listP)[count].beg_auth.asym.id = CORBA::string_dup((char*)BEG_AUTH_ASYM_ID.val);
        (*listP)[count].beg_auth.asym.index = atoi((char*)BEG_AUTH_ASYM_ID.val);
        (*listP)[count].beg_auth.comp.id = CORBA::string_dup((char*)BEG_AUTH_COMP_ID.val);
        (*listP)[count].beg_auth.comp.index = atoi((char*)BEG_AUTH_COMP_ID.val);
        (*listP)[count].beg_label.seq.id = itoa(BEG_LABEL_SEQ_ID.val);
        (*listP)[count].beg_label.seq.index = BEG_LABEL_SEQ_ID.val;
        (*listP)[count].beg_label.alt.id = CORBA::string_dup((char*)BEG_LABEL_ALT_ID.val);
        (*listP)[count].beg_label.alt.index = atoi((char*)BEG_LABEL_ALT_ID.val);
        (*listP)[count].beg_label.asym.id = CORBA::string_dup((char*)BEG_LABEL_ASYM_ID.val);
        (*listP)[count].beg_label.asym.index = atoi((char*)BEG_LABEL_ASYM_ID.val);
        (*listP)[count].beg_label.comp.id = CORBA::string_dup((char*)BEG_LABEL_COMP_ID.val);
        (*listP)[count].beg_label.comp.index = atoi((char*)BEG_LABEL_COMP_ID.val);
        (*listP)[count].end_auth.seq.id = CORBA::string_dup((char*)END_AUTH_SEQ_ID.val);
        (*listP)[count].end_auth.seq.index = atoi((char*)END_AUTH_SEQ_ID.val);
        (*listP)[count].end_auth.asym.id = CORBA::string_dup((char*)END_AUTH_ASYM_ID.val);
        (*listP)[count].end_auth.asym.index = atoi((char*)END_AUTH_ASYM_ID.val);
        (*listP)[count].end_auth.comp.id = CORBA::string_dup((char*)END_AUTH_COMP_ID.val);
        (*listP)[count].end_auth.comp.index = atoi((char*)END_AUTH_COMP_ID.val);
        (*listP)[count].end_label.seq.id = itoa(END_LABEL_SEQ_ID.val);
        (*listP)[count].end_label.seq.index = END_LABEL_SEQ_ID.val;
        (*listP)[count].end_label.alt.id = CORBA::string_dup((char*)END_LABEL_ALT_ID.val);
        (*listP)[count].end_label.alt.index = atoi((char*)END_LABEL_ALT_ID.val);
        (*listP)[count].end_label.asym.id = CORBA::string_dup((char*)END_LABEL_ASYM_ID.val);
        (*listP)[count].end_label.asym.index = atoi((char*)END_LABEL_ASYM_ID.val);
        (*listP)[count].end_label.comp.id = CORBA::string_dup((char*)END_LABEL_COMP_ID.val);
        (*listP)[count].end_label.comp.index = atoi((char*)END_LABEL_COMP_ID.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_lim_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_dom_lim_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::struct_ncs_ens_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::StructNcsEnsList*
MMS_EntryImpl::get_struct_ncs_ens_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::struct_ncs_ens_gen_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.STRUCT_NCS_ENS_GEN WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_ens_gen_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_ens_gen_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_ens_gen_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_ens_gen_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_ens_gen_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_ens_gen_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_ens_gen_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_ens_gen_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_ens_gen_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::StructNcsEnsGenList*
MMS_EntryImpl::get_struct_ncs_ens_gen_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::StructNcsEnsGenList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_ens_gen_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "STRUCT_NCS_ENS_GEN", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT DOM_ID_1,DOM_ID_2,ENS_ID,OPER_ID FROM DB2INST1.STRUCT_NCS_ENS_GEN WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_ens_gen_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_ens_gen_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_ens_gen_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_ens_gen_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } DOM_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } DOM_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ENS_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } OPER_ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &DOM_ID_1.val, 10, &DOM_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_ens_gen_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &DOM_ID_2.val, 10, &DOM_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_ens_gen_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &ENS_ID.val, 10, &ENS_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_ens_gen_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_CHAR, &OPER_ID.val, 10, &OPER_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_ens_gen_list()", "SQLBindCol 4");

    listP = new MMS::StructNcsEnsGenList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_ens_gen_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].dom_id_1.id = CORBA::string_dup((char*)DOM_ID_1.val);
        (*listP)[count].dom_id_1.index = atoi((char*)DOM_ID_1.val);
        (*listP)[count].dom_id_2.id = CORBA::string_dup((char*)DOM_ID_2.val);
        (*listP)[count].dom_id_2.index = atoi((char*)DOM_ID_2.val);
        (*listP)[count].ens.id = CORBA::string_dup((char*)ENS_ID.val);
        (*listP)[count].ens.index = atoi((char*)ENS_ID.val);
        (*listP)[count].oper.id = CORBA::string_dup((char*)OPER_ID.val);
        (*listP)[count].oper.index = atoi((char*)OPER_ID.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_ens_gen_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_ens_gen_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::struct_ncs_oper_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.STRUCT_NCS_OPER WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_oper_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_oper_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_oper_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_oper_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_oper_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_oper_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_oper_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_oper_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ncs_oper_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::StructNcsOperList*
MMS_EntryImpl::get_struct_ncs_oper_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::StructNcsOperList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_oper_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "STRUCT_NCS_OPER", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT CODE,DETAILS,ID,VECTOR1,VECTOR2,VECTOR3,MATRIX11,MATRIX12,MATRIX13,MATRIX21,MATRIX22,MATRIX23,MATRIX31,MATRIX32,MATRIX33 FROM DB2INST1.STRUCT_NCS_OPER WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_oper_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_oper_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_oper_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_oper_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } CODE;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } DETAILS;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ID;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } VECTOR1;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } VECTOR2;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } VECTOR3;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } MATRIX11;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } MATRIX12;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } MATRIX13;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } MATRIX21;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } MATRIX22;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } MATRIX23;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } MATRIX31;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } MATRIX32;

    struct {
        SQLINTEGER ind;
        SQLDOUBLE val;
    } MATRIX33;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &CODE.val, 10, &CODE.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_oper_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &DETAILS.val, 200, &DETAILS.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_oper_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &ID.val, 10, &ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_oper_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_DOUBLE, &VECTOR1.val, 0, &VECTOR1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_oper_list()", "SQLBindCol 4");

    sqlrc = SQLBindCol( hstmt, 5, SQL_C_DOUBLE, &VECTOR2.val, 0, &VECTOR2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_oper_list()", "SQLBindCol 5");

    sqlrc = SQLBindCol( hstmt, 6, SQL_C_DOUBLE, &VECTOR3.val, 0, &VECTOR3.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_oper_list()", "SQLBindCol 6");

    sqlrc = SQLBindCol( hstmt, 7, SQL_C_DOUBLE, &MATRIX11.val, 0, &MATRIX11.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_oper_list()", "SQLBindCol 7");

    sqlrc = SQLBindCol( hstmt, 8, SQL_C_DOUBLE, &MATRIX12.val, 0, &MATRIX12.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_oper_list()", "SQLBindCol 8");

    sqlrc = SQLBindCol( hstmt, 9, SQL_C_DOUBLE, &MATRIX13.val, 0, &MATRIX13.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_oper_list()", "SQLBindCol 9");

    sqlrc = SQLBindCol( hstmt, 10, SQL_C_DOUBLE, &MATRIX21.val, 0, &MATRIX21.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_oper_list()", "SQLBindCol 10");

    sqlrc = SQLBindCol( hstmt, 11, SQL_C_DOUBLE, &MATRIX22.val, 0, &MATRIX22.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_oper_list()", "SQLBindCol 11");

    sqlrc = SQLBindCol( hstmt, 12, SQL_C_DOUBLE, &MATRIX23.val, 0, &MATRIX23.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_oper_list()", "SQLBindCol 12");

    sqlrc = SQLBindCol( hstmt, 13, SQL_C_DOUBLE, &MATRIX31.val, 0, &MATRIX31.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_oper_list()", "SQLBindCol 13");

    sqlrc = SQLBindCol( hstmt, 14, SQL_C_DOUBLE, &MATRIX32.val, 0, &MATRIX32.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_oper_list()", "SQLBindCol 14");

    sqlrc = SQLBindCol( hstmt, 15, SQL_C_DOUBLE, &MATRIX33.val, 0, &MATRIX33.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_oper_list()", "SQLBindCol 15");

    listP = new MMS::StructNcsOperList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_oper_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].code = CORBA::string_dup((char*)CODE.val);
        (*listP)[count].details = CORBA::string_dup((char*)DETAILS.val);
        (*listP)[count].id = CORBA::string_dup((char*)ID.val);
        (*listP)[count].avector[0] = VECTOR1.val;
        (*listP)[count].avector[1] = VECTOR2.val;
        (*listP)[count].avector[2] = VECTOR3.val;
        (*listP)[count].matrix[0][0] = MATRIX11.val;
        (*listP)[count].matrix[0][1] = MATRIX12.val;
        (*listP)[count].matrix[0][2] = MATRIX13.val;
        (*listP)[count].matrix[1][0] = MATRIX21.val;
        (*listP)[count].matrix[1][1] = MATRIX22.val;
        (*listP)[count].matrix[1][2] = MATRIX23.val;
        (*listP)[count].matrix[2][0] = MATRIX31.val;
        (*listP)[count].matrix[2][1] = MATRIX32.val;
        (*listP)[count].matrix[2][2] = MATRIX33.val;

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_oper_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ncs_oper_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::struct_ref_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.STRUCT_REF WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::StructRefList*
MMS_EntryImpl::get_struct_ref_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::StructRefList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "STRUCT_REF", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT DB_CODE,DB_NAME,ID,BIOL_ID,ENTITY_ID FROM DB2INST1.STRUCT_REF WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[80];
    } DB_CODE;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[80];
    } DB_NAME;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[80];
    } BIOL_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ENTITY_ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &DB_CODE.val, 80, &DB_CODE.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &DB_NAME.val, 80, &DB_NAME.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &ID.val, 10, &ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_CHAR, &BIOL_ID.val, 80, &BIOL_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_list()", "SQLBindCol 4");

    sqlrc = SQLBindCol( hstmt, 5, SQL_C_CHAR, &ENTITY_ID.val, 10, &ENTITY_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_list()", "SQLBindCol 5");

    listP = new MMS::StructRefList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].db_code = CORBA::string_dup((char*)DB_CODE.val);
        (*listP)[count].db_name = CORBA::string_dup((char*)DB_NAME.val);
        (*listP)[count].id = CORBA::string_dup((char*)ID.val);
        (*listP)[count].biol.id = CORBA::string_dup((char*)BIOL_ID.val);
        (*listP)[count].biol.index = atoi((char*)BIOL_ID.val);
        (*listP)[count].entity.id = CORBA::string_dup((char*)ENTITY_ID.val);
        (*listP)[count].entity.index = atoi((char*)ENTITY_ID.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::struct_ref_seq_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.STRUCT_REF_SEQ WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_seq_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_seq_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_seq_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_seq_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_seq_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_seq_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_seq_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_seq_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_seq_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::StructRefSeqList*
MMS_EntryImpl::get_struct_ref_seq_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::StructRefSeqList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "STRUCT_REF_SEQ", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT ALIGN_ID,DB_ALIGN_BEG,DB_ALIGN_END,REF_ID,SEQ_ALIGN_BEG,SEQ_ALIGN_END FROM DB2INST1.STRUCT_REF_SEQ WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ALIGN_ID;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } DB_ALIGN_BEG;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } DB_ALIGN_END;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } REF_ID;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } SEQ_ALIGN_BEG;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } SEQ_ALIGN_END;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &ALIGN_ID.val, 10, &ALIGN_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_LONG, &DB_ALIGN_BEG.val, 0, &DB_ALIGN_BEG.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_LONG, &DB_ALIGN_END.val, 0, &DB_ALIGN_END.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_CHAR, &REF_ID.val, 10, &REF_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_list()", "SQLBindCol 4");

    sqlrc = SQLBindCol( hstmt, 5, SQL_C_LONG, &SEQ_ALIGN_BEG.val, 0, &SEQ_ALIGN_BEG.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_list()", "SQLBindCol 5");

    sqlrc = SQLBindCol( hstmt, 6, SQL_C_LONG, &SEQ_ALIGN_END.val, 0, &SEQ_ALIGN_END.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_list()", "SQLBindCol 6");

    listP = new MMS::StructRefSeqList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].align_id = CORBA::string_dup((char*)ALIGN_ID.val);
        (*listP)[count].db_align_beg = DB_ALIGN_BEG.val;
        (*listP)[count].db_align_end = DB_ALIGN_END.val;
        (*listP)[count].ref.id = CORBA::string_dup((char*)REF_ID.val);
        (*listP)[count].ref.index = atoi((char*)REF_ID.val);
        (*listP)[count].seq_align_beg.id = itoa(SEQ_ALIGN_BEG.val);
        (*listP)[count].seq_align_beg.index = SEQ_ALIGN_BEG.val;
        (*listP)[count].seq_align_end.id = itoa(SEQ_ALIGN_END.val);
        (*listP)[count].seq_align_end.index = SEQ_ALIGN_END.val;

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::struct_ref_seq_dif_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.STRUCT_REF_SEQ_DIF WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_seq_dif_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_seq_dif_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_seq_dif_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_seq_dif_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_seq_dif_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_seq_dif_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_seq_dif_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_seq_dif_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_ref_seq_dif_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::StructRefSeqDifList*
MMS_EntryImpl::get_struct_ref_seq_dif_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::StructRefSeqDifList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_dif_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "STRUCT_REF_SEQ_DIF", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT DETAILS,ALIGN_ID,DB_MON_ID,MON_ID,SEQ_NUM FROM DB2INST1.STRUCT_REF_SEQ_DIF WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_dif_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_dif_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_dif_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_dif_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } DETAILS;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ALIGN_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } DB_MON_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } MON_ID;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } SEQ_NUM;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &DETAILS.val, 200, &DETAILS.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_dif_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &ALIGN_ID.val, 10, &ALIGN_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_dif_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &DB_MON_ID.val, 10, &DB_MON_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_dif_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_CHAR, &MON_ID.val, 10, &MON_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_dif_list()", "SQLBindCol 4");

    sqlrc = SQLBindCol( hstmt, 5, SQL_C_LONG, &SEQ_NUM.val, 0, &SEQ_NUM.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_dif_list()", "SQLBindCol 5");

    listP = new MMS::StructRefSeqDifList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_dif_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].details = CORBA::string_dup((char*)DETAILS.val);
        (*listP)[count].align.id = CORBA::string_dup((char*)ALIGN_ID.val);
        (*listP)[count].align.index = atoi((char*)ALIGN_ID.val);
        (*listP)[count].db_mon.id = CORBA::string_dup((char*)DB_MON_ID.val);
        (*listP)[count].db_mon.index = atoi((char*)DB_MON_ID.val);
        (*listP)[count].mon.id = CORBA::string_dup((char*)MON_ID.val);
        (*listP)[count].mon.index = atoi((char*)MON_ID.val);
        (*listP)[count].seq_num.id = itoa(SEQ_NUM.val);
        (*listP)[count].seq_num.index = SEQ_NUM.val;

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_dif_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_ref_seq_dif_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::struct_sheet_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.STRUCT_SHEET WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::StructSheetList*
MMS_EntryImpl::get_struct_sheet_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::StructSheetList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "STRUCT_SHEET", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT DETAILS,ID,NUMBER_STRANDS,TYPE FROM DB2INST1.STRUCT_SHEET WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } DETAILS;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ID;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } NUMBER_STRANDS;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } TYPE;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &DETAILS.val, 200, &DETAILS.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &ID.val, 10, &ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_LONG, &NUMBER_STRANDS.val, 0, &NUMBER_STRANDS.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_CHAR, &TYPE.val, 200, &TYPE.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_list()", "SQLBindCol 4");

    listP = new MMS::StructSheetList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].details = CORBA::string_dup((char*)DETAILS.val);
        (*listP)[count].id = CORBA::string_dup((char*)ID.val);
        (*listP)[count].number_strands = NUMBER_STRANDS.val;
        (*listP)[count].type = CORBA::string_dup((char*)TYPE.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::struct_sheet_hbond_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::StructSheetHbondList*
MMS_EntryImpl::get_struct_sheet_hbond_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::struct_sheet_order_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.STRUCT_SHEET_ORDER WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_order_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_order_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_order_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_order_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_order_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_order_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_order_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_order_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_order_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::StructSheetOrderList*
MMS_EntryImpl::get_struct_sheet_order_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::StructSheetOrderList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_order_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "STRUCT_SHEET_ORDER", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT OFFSET,SENSE,RANGE_ID_1,RANGE_ID_2,SHEET_ID FROM DB2INST1.STRUCT_SHEET_ORDER WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_order_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_order_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_order_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_order_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } OFFSET;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[20];
    } SENSE;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } RANGE_ID_1;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } RANGE_ID_2;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } SHEET_ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_LONG, &OFFSET.val, 0, &OFFSET.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_order_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &SENSE.val, 20, &SENSE.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_order_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &RANGE_ID_1.val, 10, &RANGE_ID_1.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_order_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_CHAR, &RANGE_ID_2.val, 10, &RANGE_ID_2.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_order_list()", "SQLBindCol 4");

    sqlrc = SQLBindCol( hstmt, 5, SQL_C_CHAR, &SHEET_ID.val, 10, &SHEET_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_order_list()", "SQLBindCol 5");

    listP = new MMS::StructSheetOrderList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_order_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].offset = OFFSET.val;
        (*listP)[count].sense = CORBA::string_dup((char*)SENSE.val);
        (*listP)[count].range_id_1.id = CORBA::string_dup((char*)RANGE_ID_1.val);
        (*listP)[count].range_id_1.index = atoi((char*)RANGE_ID_1.val);
        (*listP)[count].range_id_2.id = CORBA::string_dup((char*)RANGE_ID_2.val);
        (*listP)[count].range_id_2.index = atoi((char*)RANGE_ID_2.val);
        (*listP)[count].sheet.id = CORBA::string_dup((char*)SHEET_ID.val);
        (*listP)[count].sheet.index = atoi((char*)SHEET_ID.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_order_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_order_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::struct_sheet_range_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.STRUCT_SHEET_RANGE WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_range_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_range_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_range_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_range_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_range_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_range_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_range_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_range_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_sheet_range_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::StructSheetRangeList*
MMS_EntryImpl::get_struct_sheet_range_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::StructSheetRangeList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_range_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "STRUCT_SHEET_RANGE", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT ID,SYMMETRY,SHEET_ID,BEG_AUTH_ASYM_ID,BEG_AUTH_COMP_ID,BEG_AUTH_SEQ_ID,BEG_LABEL_ASYM_ID,BEG_LABEL_COMP_ID,BEG_LABEL_SEQ_ID,END_AUTH_ASYM_ID,END_AUTH_COMP_ID,END_AUTH_SEQ_ID,END_LABEL_ASYM_ID,END_LABEL_COMP_ID,END_LABEL_SEQ_ID FROM DB2INST1.STRUCT_SHEET_RANGE WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_range_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_range_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_range_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_range_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } SYMMETRY;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } SHEET_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } BEG_AUTH_ASYM_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } BEG_AUTH_COMP_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } BEG_AUTH_SEQ_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } BEG_LABEL_ASYM_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } BEG_LABEL_COMP_ID;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } BEG_LABEL_SEQ_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } END_AUTH_ASYM_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } END_AUTH_COMP_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } END_AUTH_SEQ_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } END_LABEL_ASYM_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } END_LABEL_COMP_ID;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } END_LABEL_SEQ_ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &ID.val, 10, &ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_range_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &SYMMETRY.val, 10, &SYMMETRY.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_range_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &SHEET_ID.val, 10, &SHEET_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_range_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_CHAR, &BEG_AUTH_ASYM_ID.val, 10, &BEG_AUTH_ASYM_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_range_list()", "SQLBindCol 4");

    sqlrc = SQLBindCol( hstmt, 5, SQL_C_CHAR, &BEG_AUTH_COMP_ID.val, 10, &BEG_AUTH_COMP_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_range_list()", "SQLBindCol 5");

    sqlrc = SQLBindCol( hstmt, 6, SQL_C_CHAR, &BEG_AUTH_SEQ_ID.val, 10, &BEG_AUTH_SEQ_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_range_list()", "SQLBindCol 6");

    sqlrc = SQLBindCol( hstmt, 7, SQL_C_CHAR, &BEG_LABEL_ASYM_ID.val, 10, &BEG_LABEL_ASYM_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_range_list()", "SQLBindCol 7");

    sqlrc = SQLBindCol( hstmt, 8, SQL_C_CHAR, &BEG_LABEL_COMP_ID.val, 10, &BEG_LABEL_COMP_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_range_list()", "SQLBindCol 8");

    sqlrc = SQLBindCol( hstmt, 9, SQL_C_LONG, &BEG_LABEL_SEQ_ID.val, 0, &BEG_LABEL_SEQ_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_range_list()", "SQLBindCol 9");

    sqlrc = SQLBindCol( hstmt, 10, SQL_C_CHAR, &END_AUTH_ASYM_ID.val, 10, &END_AUTH_ASYM_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_range_list()", "SQLBindCol 10");

    sqlrc = SQLBindCol( hstmt, 11, SQL_C_CHAR, &END_AUTH_COMP_ID.val, 10, &END_AUTH_COMP_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_range_list()", "SQLBindCol 11");

    sqlrc = SQLBindCol( hstmt, 12, SQL_C_CHAR, &END_AUTH_SEQ_ID.val, 10, &END_AUTH_SEQ_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_range_list()", "SQLBindCol 12");

    sqlrc = SQLBindCol( hstmt, 13, SQL_C_CHAR, &END_LABEL_ASYM_ID.val, 10, &END_LABEL_ASYM_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_range_list()", "SQLBindCol 13");

    sqlrc = SQLBindCol( hstmt, 14, SQL_C_CHAR, &END_LABEL_COMP_ID.val, 10, &END_LABEL_COMP_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_range_list()", "SQLBindCol 14");

    sqlrc = SQLBindCol( hstmt, 15, SQL_C_LONG, &END_LABEL_SEQ_ID.val, 0, &END_LABEL_SEQ_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_range_list()", "SQLBindCol 15");

    listP = new MMS::StructSheetRangeList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_range_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].id = CORBA::string_dup((char*)ID.val);
        (*listP)[count].symmetry = CORBA::string_dup((char*)SYMMETRY.val);
        (*listP)[count].sheet.id = CORBA::string_dup((char*)SHEET_ID.val);
        (*listP)[count].sheet.index = atoi((char*)SHEET_ID.val);
        (*listP)[count].beg_auth.seq.id = CORBA::string_dup((char*)BEG_AUTH_SEQ_ID.val);
        (*listP)[count].beg_auth.seq.index = atoi((char*)BEG_AUTH_SEQ_ID.val);
        (*listP)[count].beg_auth.asym.id = CORBA::string_dup((char*)BEG_AUTH_ASYM_ID.val);
        (*listP)[count].beg_auth.asym.index = atoi((char*)BEG_AUTH_ASYM_ID.val);
        (*listP)[count].beg_auth.comp.id = CORBA::string_dup((char*)BEG_AUTH_COMP_ID.val);
        (*listP)[count].beg_auth.comp.index = atoi((char*)BEG_AUTH_COMP_ID.val);
        (*listP)[count].beg_label.seq.id = itoa(BEG_LABEL_SEQ_ID.val);
        (*listP)[count].beg_label.seq.index = BEG_LABEL_SEQ_ID.val;
        (*listP)[count].beg_label.asym.id = CORBA::string_dup((char*)BEG_LABEL_ASYM_ID.val);
        (*listP)[count].beg_label.asym.index = atoi((char*)BEG_LABEL_ASYM_ID.val);
        (*listP)[count].beg_label.comp.id = CORBA::string_dup((char*)BEG_LABEL_COMP_ID.val);
        (*listP)[count].beg_label.comp.index = atoi((char*)BEG_LABEL_COMP_ID.val);
        (*listP)[count].end_auth.seq.id = CORBA::string_dup((char*)END_AUTH_SEQ_ID.val);
        (*listP)[count].end_auth.seq.index = atoi((char*)END_AUTH_SEQ_ID.val);
        (*listP)[count].end_auth.asym.id = CORBA::string_dup((char*)END_AUTH_ASYM_ID.val);
        (*listP)[count].end_auth.asym.index = atoi((char*)END_AUTH_ASYM_ID.val);
        (*listP)[count].end_auth.comp.id = CORBA::string_dup((char*)END_AUTH_COMP_ID.val);
        (*listP)[count].end_auth.comp.index = atoi((char*)END_AUTH_COMP_ID.val);
        (*listP)[count].end_label.seq.id = itoa(END_LABEL_SEQ_ID.val);
        (*listP)[count].end_label.seq.index = END_LABEL_SEQ_ID.val;
        (*listP)[count].end_label.asym.id = CORBA::string_dup((char*)END_LABEL_ASYM_ID.val);
        (*listP)[count].end_label.asym.index = atoi((char*)END_LABEL_ASYM_ID.val);
        (*listP)[count].end_label.comp.id = CORBA::string_dup((char*)END_LABEL_COMP_ID.val);
        (*listP)[count].end_label.comp.index = atoi((char*)END_LABEL_COMP_ID.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_range_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_sheet_range_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::struct_sheet_topology_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::StructSheetTopologyList*
MMS_EntryImpl::get_struct_sheet_topology_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


CORBA::Long
MMS_EntryImpl::struct_site_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.STRUCT_SITE WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::StructSiteList*
MMS_EntryImpl::get_struct_site_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::StructSiteList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "STRUCT_SITE", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT DETAILS,ID FROM DB2INST1.STRUCT_SITE WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[4000];
    } DETAILS;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[80];
    } ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &DETAILS.val, 4000, &DETAILS.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &ID.val, 80, &ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_list()", "SQLBindCol 2");

    listP = new MMS::StructSiteList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].details = CORBA::string_dup((char*)DETAILS.val);
        (*listP)[count].id = CORBA::string_dup((char*)ID.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::struct_site_gen_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.STRUCT_SITE_GEN WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_gen_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_gen_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_gen_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_gen_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_gen_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_gen_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_gen_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_gen_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_gen_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::StructSiteGenList*
MMS_EntryImpl::get_struct_site_gen_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::StructSiteGenList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_gen_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "STRUCT_SITE_GEN", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT DETAILS,ID,SYMMETRY,SITE_ID,AUTH_ASYM_ID,AUTH_COMP_ID,AUTH_SEQ_ID,LABEL_ALT_ID,LABEL_ASYM_ID,LABEL_ATOM_ID,LABEL_COMP_ID,LABEL_SEQ_ID FROM DB2INST1.STRUCT_SITE_GEN WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_gen_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_gen_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_gen_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_gen_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } DETAILS;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[80];
    } ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } SYMMETRY;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[80];
    } SITE_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } AUTH_ASYM_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } AUTH_COMP_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } AUTH_SEQ_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } LABEL_ALT_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } LABEL_ASYM_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[6];
    } LABEL_ATOM_ID;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[10];
    } LABEL_COMP_ID;

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } LABEL_SEQ_ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &DETAILS.val, 200, &DETAILS.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_gen_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &ID.val, 80, &ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_gen_list()", "SQLBindCol 2");

    sqlrc = SQLBindCol( hstmt, 3, SQL_C_CHAR, &SYMMETRY.val, 10, &SYMMETRY.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_gen_list()", "SQLBindCol 3");

    sqlrc = SQLBindCol( hstmt, 4, SQL_C_CHAR, &SITE_ID.val, 80, &SITE_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_gen_list()", "SQLBindCol 4");

    sqlrc = SQLBindCol( hstmt, 5, SQL_C_CHAR, &AUTH_ASYM_ID.val, 10, &AUTH_ASYM_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_gen_list()", "SQLBindCol 5");

    sqlrc = SQLBindCol( hstmt, 6, SQL_C_CHAR, &AUTH_COMP_ID.val, 10, &AUTH_COMP_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_gen_list()", "SQLBindCol 6");

    sqlrc = SQLBindCol( hstmt, 7, SQL_C_CHAR, &AUTH_SEQ_ID.val, 10, &AUTH_SEQ_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_gen_list()", "SQLBindCol 7");

    sqlrc = SQLBindCol( hstmt, 8, SQL_C_CHAR, &LABEL_ALT_ID.val, 10, &LABEL_ALT_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_gen_list()", "SQLBindCol 8");

    sqlrc = SQLBindCol( hstmt, 9, SQL_C_CHAR, &LABEL_ASYM_ID.val, 10, &LABEL_ASYM_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_gen_list()", "SQLBindCol 9");

    sqlrc = SQLBindCol( hstmt, 10, SQL_C_CHAR, &LABEL_ATOM_ID.val, 6, &LABEL_ATOM_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_gen_list()", "SQLBindCol 10");

    sqlrc = SQLBindCol( hstmt, 11, SQL_C_CHAR, &LABEL_COMP_ID.val, 10, &LABEL_COMP_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_gen_list()", "SQLBindCol 11");

    sqlrc = SQLBindCol( hstmt, 12, SQL_C_LONG, &LABEL_SEQ_ID.val, 0, &LABEL_SEQ_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_gen_list()", "SQLBindCol 12");

    listP = new MMS::StructSiteGenList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_gen_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].details = CORBA::string_dup((char*)DETAILS.val);
        (*listP)[count].id = CORBA::string_dup((char*)ID.val);
        (*listP)[count].symmetry = CORBA::string_dup((char*)SYMMETRY.val);
        (*listP)[count].site.id = CORBA::string_dup((char*)SITE_ID.val);
        (*listP)[count].site.index = atoi((char*)SITE_ID.val);
        (*listP)[count].auth.asym.id = CORBA::string_dup((char*)AUTH_ASYM_ID.val);
        (*listP)[count].auth.asym.index = atoi((char*)AUTH_ASYM_ID.val);
        (*listP)[count].auth.comp.id = CORBA::string_dup((char*)AUTH_COMP_ID.val);
        (*listP)[count].auth.comp.index = atoi((char*)AUTH_COMP_ID.val);
        (*listP)[count].auth.seq.id = CORBA::string_dup((char*)AUTH_SEQ_ID.val);
        (*listP)[count].auth.seq.index = atoi((char*)AUTH_SEQ_ID.val);
        (*listP)[count].label.atom.id = CORBA::string_dup((char*)LABEL_ATOM_ID.val);
        (*listP)[count].label.atom.index = atoi((char*)LABEL_ATOM_ID.val);
        (*listP)[count].label.alt.id = CORBA::string_dup((char*)LABEL_ALT_ID.val);
        (*listP)[count].label.alt.index = atoi((char*)LABEL_ALT_ID.val);
        (*listP)[count].label.asym.id = CORBA::string_dup((char*)LABEL_ASYM_ID.val);
        (*listP)[count].label.asym.index = atoi((char*)LABEL_ASYM_ID.val);
        (*listP)[count].label.comp.id = CORBA::string_dup((char*)LABEL_COMP_ID.val);
        (*listP)[count].label.comp.index = atoi((char*)LABEL_COMP_ID.val);
        (*listP)[count].label.seq.id = itoa(LABEL_SEQ_ID.val);
        (*listP)[count].label.seq.index = LABEL_SEQ_ID.val;

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_gen_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_gen_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::struct_site_keywords_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    SQLCHAR * stmt = ( SQLCHAR * )
        "SELECT count(*) FROM DB2INST1.STRUCT_SITE_KEYWORDS WHERE structure_id = ?";

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_keywords_list_size()", "no connections!");
    }

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_keywords_list_size()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_keywords_list_size()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_keywords_list_size()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_keywords_list_size()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLINTEGER val;
    } total;

    sqlrc = SQLBindCol(hstmt, 1, SQL_C_LONG, &total.val, 0, &total.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_keywords_list_size()", "SQLBindCol");

    sqlrc = SQLFetch(hstmt);
    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_keywords_list_size()", "SQLFetch");

    if (sqlrc == SQL_NO_DATA_FOUND)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_keywords_list_size()", "no data");

    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::struct_site_keywords_list_size()", "SQLFreeHandle");

finish:
    return total.val;
}

MMS::StructSiteKeywordsList*
MMS_EntryImpl::get_struct_site_keywords_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    SQLRETURN   sqlrc = SQL_SUCCESS;
    SQLHANDLE   hdbc; // connection handle
    SQLHANDLE   hstmt ; // statement handle
    char        structure_id[10];

    MMS::StructSiteKeywordsList* listP = 0;
    CORBA::ULong count;
    SQLCHAR * stmt;

    try {
        connpool::Connection conn;
        hdbc = conn.hdbc;
        } catch (DBException) {
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_keywords_list()", "no connections!");
    }

    CORBA::ULong listSize = list_size(hdbc, "STRUCT_SITE_KEYWORDS", _id);
    if (!listSize) goto finish;

;    stmt = ( SQLCHAR * )
        "SELECT TEXT,SITE_ID FROM DB2INST1.STRUCT_SITE_KEYWORDS WHERE structure_id = ?";

    sqlrc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_keywords_list()", "SQLAllocHandle");

    sqlrc = SQLPrepare(hstmt, stmt, SQL_NTS);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_keywords_list()", "SQLPrepare");

    sqlrc = SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 10, 0, structure_id, 10, NULL);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_keywords_list()", "SQLBindParameter");

    strcpy( structure_id, (char*)_idV);
    sqlrc = SQLExecute(hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_keywords_list()", "SQLExecute");

    struct {
        SQLINTEGER ind;
        SQLCHAR val[200];
    } TEXT;

    struct {
        SQLINTEGER ind;
        SQLCHAR val[80];
    } SITE_ID;

    sqlrc = SQLBindCol( hstmt, 1, SQL_C_CHAR, &TEXT.val, 200, &TEXT.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_keywords_list()", "SQLBindCol 1");

    sqlrc = SQLBindCol( hstmt, 2, SQL_C_CHAR, &SITE_ID.val, 80, &SITE_ID.ind);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_keywords_list()", "SQLBindCol 2");

    listP = new MMS::StructSiteKeywordsList(listSize);
    listP->length(listSize);
    count = 0;

    sqlrc = SQLFetch(hstmt);
    if (sqlrc == SQL_NO_DATA_FOUND) goto finish;

    if (sqlrc != SQL_SUCCESS && sqlrc != SQL_SUCCESS_WITH_INFO)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_keywords_list()", "SQLFetch first");

    while (sqlrc != SQL_NO_DATA_FOUND) {
        (*listP)[count].text = CORBA::string_dup((char*)TEXT.val);
        (*listP)[count].site.id = CORBA::string_dup((char*)SITE_ID.val);
        (*listP)[count].site.index = atoi((char*)SITE_ID.val);

        ++count;

        sqlrc = SQLFetch(hstmt);
        if (sqlrc != SQL_SUCCESS && sqlrc != SQL_NO_DATA_FOUND)
            throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_keywords_list()", "SQLFetch loop");
    }
    sqlrc = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if (sqlrc != SQL_SUCCESS)
        throw MMS::DataAccessException("MMS_EntryImpl::get_struct_site_keywords_list()", "SQLFreeHandle");

finish:
    return listP;
}


CORBA::Long
MMS_EntryImpl::struct_site_view_list_size()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}

MMS::StructSiteViewList*
MMS_EntryImpl::get_struct_site_view_list()
    throw (CORBA::SystemException, MMS::DataAccessException)
{
    return 0;
}


